function U10 = cspd2wspd_byEkman(V0,Phi)
% calculate wind speed at 10m height from ageostrophic ocean current speed based on Ekman theory

% U10 = cspd2wspd_byEkman(V0,Phi)

% Input: V0 and Phi must be the same size, scalar or vector
% V0: ageostrophic ocean current speed
% Phi: latitude of V0

% Ouput: U10 is the same size as V0/Phi
% U10: the corresponding wind speed at 10m height

% Reference
% Stewart,R. H. (2008) Introduction to physical oceanography


U10 = (V0 * sqrt(sind(abs(Phi))))/0.0127;

end




