% figure 1 code 2


clear;clc
path_in='/datas/drifter_locations/';
path_out='/datas/drifterlocations_TCnumbers/';
files=dir([path_in,'*drifter within TC 7Rmax-TS1.dat']);

lat_drifter_all=[];
lon_drifter_all=[];
date_drifter_all=[];
lat_tc_all=[];
lon_tc_all=[];
date_tc_all=[];
for i=1:length(files)
    fid=fopen([path_in,files(i).name]);
    data=textscan(fid,'%15d%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15d%15.4f%15.4f%15.4f%15.4f','headerlines',1);
    fclose(fid);
    date_drifter=data{1};
    lat_drifter=data{2};
    lon_drifter=data{3};
    date_tc=data{8};
    lat_tc=data{9};
    lon_tc=data{10};
    
    datestr_drifter=num2str(date_drifter);
    year_drifter=str2num(datestr_drifter(:,1:4));
    idx=find(year_drifter>=1991 & year_drifter<=2020);
    date_drifter=date_drifter(idx);
    lat_drifter=lat_drifter(idx);
    lon_drifter=lon_drifter(idx);
    lon_drifter(lon_drifter<0)=lon_drifter(lon_drifter<0)+360;
    date_tc=date_tc(idx);
    lat_tc=lat_tc(idx);
    lon_tc=lon_tc(idx);
    lon_tc(lon_tc<0)=lon_tc(lon_tc<0)+360;
    
    lat_drifter_all=[lat_drifter_all;lat_drifter];
    lon_drifter_all=[lon_drifter_all;lon_drifter];
    date_drifter_all=[date_drifter_all;date_drifter];
    lat_tc_all=[lat_tc_all;lat_tc];
    lon_tc_all=[lon_tc_all;lon_tc];
    date_tc_all=[date_tc_all;date_tc];
    
    clear fid data idx
end

lon_grid=0:6:360;
lat_grid=-70:3:70;
num_TCs=NaN(length(lat_grid),length(lon_grid));
for i=1:length(lon_grid)
    for j=1:length(lat_grid)
        num_TCs(j,i)=length( find( (lat_tc_all>=lat_grid(j)-1.5 & lat_tc_all<=lat_grid(j)+1.5) ...
            & (lon_tc_all>=lon_grid(i)-3 & lon_tc_all<=lon_grid(i)+3) ) );
    end
end

save([path_out,'drifterLocations_TCnumbers_TS1_1991_2020'],'lon_drifter_all','lat_drifter_all','num_TCs');




