% figure 1 plot


clear;clc;
path_in='/datas/drifterlocations_TCnumbers/';
path_figure='/figures/fig1/';

load([path_in,'drifterLocations_TCnumbers_TS1_1991_2020.mat']);

lon_grid=0:6:360;
lat_grid=-70:3:70;
[Lon_grid,Lat_grid]=meshgrid(lon_grid,lat_grid);

% plot
f=figure;
set(f,'unit','centimeters','position',[2,5,40,40]);
m_proj('Miller','lon',[0 360],'lat',[-70 70]);
m_coast('patch',[0.602 0.602 0.602],'edgecolor',[0.602 0.602 0.602]);
m_grid('box','on','linestyle','none','ytick',-60:20:60,'xtick',0:60:360,'fontname','Arial','fontunits','point','fontsize',7,'ticklength',0.01);
hold on
% drifter locations
hh=m_plot(lon_drifter_all,lat_drifter_all,'o','markerfacecolor','m','markeredgecolor','m','markersize',1);
% TC number
[c,h]=m_contour(Lon_grid,Lat_grid,num_TCs,[50 100 200 300 500 700],'linewidth',1,'color',[0 0.45 0.75]);
text_handle=clabel(c, h,'manual');
set(text_handle,'rotation',0,'fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold','color','k');
xlabel('Longitude','fontname','Arial','fontunits','point','fontsize',7);
ylabel('Latitude','fontname','Arial','fontunits','point','fontsize',7,'rotation',90);
set(gcf,'color','w');

set(f,'RendererMode','manual','Renderer','painters');
print('-r600',[path_figure,'drifterTCLocation_TS1_1991-2020'],'-depsc');
close(f);




