% figure 2 code 1


clear;clc;
path_ssh='/datas/dt_grid_madt_all_h/';
path_out='/datas/geostrophic u_v/';

folders=dir(path_ssh);
num_folders=length(folders)-2;

lon = 0.125:0.25:359.875;
lat = -89.875:0.25:89.875;
R = 6378E3;
DR = 2*pi*R/360;
DRLat = DR * cosd(lat);
g=9.8;
f = 2*7.292E-5*sind(lat);

u_all=zeros(length(lon),length(lat),366);
v_all=zeros(length(lon),length(lat),366);
mask_u_all=zeros(length(lon),length(lat),366);
mask_v_all=zeros(length(lon),length(lat),366);

for i=1:num_folders
    files=dir([path_ssh,folders(i+2).name,'/','*.nc']);
    num_files=length(files);
    
    for j=1:num_files
        filename=[path_ssh,folders(i+2).name,'/',files(j).name];
        
        date=filename(96:103);
        day0=datenum(str2double(date(1:4)),str2double(date(5:6)),str2double(date(7:8)));
        v = datevec(day0);
        day1 = datenum(v(1),01,01);
        dd = day0-day1;
        year_day=dd+1;
        clear day0 v day1 dd
        
        if(~((rem(str2num(date(1:4)),100)~= 0 && rem(str2num(date(1:4)),4) == 0) ||...
                (rem(str2num(date(1:4)),100) == 0 && rem(str2num(date(1:4)),400) == 0)))
            if (year_day>59)
                year_day=year_day+1;
            end
        end
        
        %　ncdisp(filename);
        ssh=ncread(filename,'adt');
        ssh=ssh.*100;
        % lon_adt=ncread(filename,'lon');
        % lat_adt=ncread(filename,'lat');
        
        v=nan(1440,720);
        u=nan(1440,720);
        
        for m = 1:length(lat)
            for n = 1:length(lon)-1
                v(n,m) = g/f(m)*(ssh(n+1,m) - ssh(n,m))/(lon(n+1)-lon(n))/DRLat(m);
            end
        end
        
        for m = 1:length(lat)-1
            u(:,m) = -g/f(m)*(ssh(:,m+1) - ssh(:,m))/(lat(m+1)-lat(m))/DR;
        end
        
        mask_u=~isnan(u);
        mask_u_all(:,:,year_day)=mask_u_all(:,:,year_day)+mask_u;
        u(isnan(u))=0;
        u_all(:,:,year_day)=u_all(:,:,year_day)+u;
        
        mask_v=~isnan(v);
        mask_v_all(:,:,year_day)=mask_v_all(:,:,year_day)+mask_v;
        v(isnan(v))=0;
        v_all(:,:,year_day)=v_all(:,:,year_day)+v;
        
        clear  v u
    end
end

u_clim=u_all./mask_u_all;
v_clim=v_all./mask_v_all;
save([path_out,'geostrophicFlow_global_clim.mat'],'u_clim','v_clim','lon','lat','-v7.3');  % cm/s




