% figure 2 code 3


clear;clc;
path_drifter='/datas/drifter_locations/';
path_uv = '/datas/geostrophic u_v/';
path_out='/datas/ageostrophic u_v/';
files_drifter=dir([path_drifter,'*drifter within TC 7Rmax-TS1.dat']);

load([path_uv,'geostrophicFlow_global_clim.mat']);
[lon_meshgrid,lat_meshgrid]=meshgrid(lon,lat);

basin={'na','nep','nio','nwp','sio','sp'};
for m=1:length(files_drifter)
    disp(m);
    
    % drifter data
    file_drifter=[path_drifter,files_drifter(m).name];
    fid_drifter=fopen(file_drifter);
    data_drifter=textscan(fid_drifter,'%15d%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15d%15.4f%15.4f%15.4f%15.4f','headerlines',1);
    % data:drifter_date,drifter_lat,drifter_lon,drifter_T,drifter_Ve,drifter_Vn,drifter_speed,TC_date,TC_lat,TC_lon,r_along,r_cross
    fclose(fid_drifter);
    dateTime_drifter=data_drifter{1};
    Lat_drifter=data_drifter{2};
    Lon_drifter=data_drifter{3};
    Lon_drifter(Lon_drifter<0)=Lon_drifter(Lon_drifter<0)+360;
    u_drifter=data_drifter{5};
    v_drifter=data_drifter{6};
    idx=find(Lat_drifter>999 | Lon_drifter>999 | u_drifter>999 | v_drifter>999);
    dateTime_drifter(idx)=[];
    Lat_drifter(idx)=[];
    Lon_drifter(idx)=[];
    u_drifter(idx)=[];
    v_drifter(idx)=[];
    clear file_drifter fid_drifter data_drifter idx
    
    DATE_drifter=[];
    LAT_drifter=[];
    LON_drifter=[];
    U_drifter_origin=[];
    V_drifter_origin=[];
    U_drifter_geo=[];
    V_drifter_geo=[];
    
    for i=1:length(dateTime_drifter)
        date_drifter=dateTime_drifter(i);
        datestr_drifter=num2str(date_drifter);
        lat_drifter=Lat_drifter(i);
        lon_drifter=Lon_drifter(i);
        
        day0=datenum(str2double(datestr_drifter(1:4)),str2double(datestr_drifter(5:6)),str2double(datestr_drifter(7:8)));
        v = datevec(day0);
        day1 = datenum(v(1),01,01);
        dd = day0-day1;
        year_day=dd+1;
        clear day0 v day1 dd
        
        if(~((rem(str2double(datestr_drifter(1:4)),100)~= 0 && rem(str2double(datestr_drifter(1:4)),4) == 0) ||...
                (rem(str2double(datestr_drifter(1:4)),100) == 0 && rem(str2double(datestr_drifter(1:4)),400) == 0)))
            if (year_day>59)
                year_day=year_day+1;
            end
        end
        
        u_drifter_geo=interp2(lon_meshgrid,lat_meshgrid,u_clim(:,:,year_day)',lon_drifter,lat_drifter);
        v_drifter_geo=interp2(lon_meshgrid,lat_meshgrid,v_clim(:,:,year_day)',lon_drifter,lat_drifter);
        
        DATE_drifter=[DATE_drifter;date_drifter];
        LAT_drifter=[LAT_drifter;lat_drifter];
        LON_drifter=[LON_drifter;lon_drifter];
        U_drifter_origin=[U_drifter_origin;u_drifter(i)];
        V_drifter_origin=[V_drifter_origin;v_drifter(i)];
        U_drifter_geo=[U_drifter_geo;u_drifter_geo];
        V_drifter_geo=[V_drifter_geo;v_drifter_geo];
        
        clear date_drifter datestr_drifter lat_drifter lon_drifter year_day u_drifter_geo v_drifter_geo
    end
    
    Ue=U_drifter_origin-U_drifter_geo;
    Ve=V_drifter_origin-V_drifter_geo;
    
    U_drifter_origin=U_drifter_origin./100;
    V_drifter_origin=V_drifter_origin./100;
    U_drifter_geo=U_drifter_geo./100;
    V_drifter_geo=V_drifter_geo./100;
    Ue=Ue./100;
    Ve=Ve./100;
    
    save([path_out,basin{m},'_ageostrophicFlow_19792020.mat'],'DATE_drifter','LON_drifter','LAT_drifter',...
        'V_drifter_origin','U_drifter_origin','V_drifter_geo','U_drifter_geo','Ve','Ue','-v7.3');
    
    clear DATE_drifter LON_drifter LAT_drifter V_drifter_origin U_drifter_origin V_drifter_geo
    clear U_drifter_geo Ve Ue dateTime_drifter Lat_drifter Lon_drifter u_drifter v_drifter
end




