% figure 2 code 4


% NA
clear;clc;
path_drifter='/datas/ageostrophic u_v/';
path_tc='/datas/Hurdat/Hurdat_at-intensity-bySSS_1979-2020_step2/';
path_out = '/datas/current in storm-coordinate system/';

% ageostrophic flow
load([path_drifter,'na_ageostrophicFlow_19792020.mat']);
x=[double(DATE_drifter),LON_drifter,LAT_drifter];
[~,idx]=unique(x,'rows');
DATE_drifter=DATE_drifter(idx);
LAT_drifter=LAT_drifter(idx);
LON_drifter=LON_drifter(idx);
Ue=Ue(idx);
Ve=Ve(idx);
U_drifter_origin=U_drifter_origin(idx);
V_drifter_origin=V_drifter_origin(idx);
U_drifter_geo=U_drifter_geo(idx);
V_drifter_geo=V_drifter_geo(idx);
clear x idx

% TC
folders_tc=dir(path_tc);

fid_write = fopen([path_out,'na-ageostrophicFlowInStormCoordinateSystem_withinTC7Rmax_TS1_19792020.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s',...
    'date_drifter','lon_drifter','lat_drifter','r_along','r_cross','Ve','Ue','Vorigin',...
    'Uorigin','Vgeo','Ugeo','date_tc','lon_tc','lat_tc','Vmax','Rmax');
fprintf(fid_write,'\n');

tc_name=[];
for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%d%d%d%d%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Vmax_tc=data_tc{4};
        Rmax_tc=double(data_tc{9});
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==DATE_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                if (Rmax==0)
                    disp(1);
                    continue
                end
                
                for q=1:length(idx)
                    % rotate r
                    lat_drifter=LAT_drifter(idx(q));
                    lon_drifter=LON_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    % roate u & v
                    U_drifter = Ue(idx(q));
                    V_drifter = Ve(idx(q));
                    u_drifter_origin=U_drifter_origin(idx(q));
                    v_drifter_origin=V_drifter_origin(idx(q));
                    u_drifter_geo=U_drifter_geo(idx(q));
                    v_drifter_geo=V_drifter_geo(idx(q));
                    
                    U_drifter_across=U_drifter*sind(beta);
                    V_drifter_across=-V_drifter*cosd(beta);
                    U_drifter_along=U_drifter*cosd(beta);
                    V_drifter_along=V_drifter*sind(beta);
                    U1=U_drifter_across+V_drifter_across;
                    V1=U_drifter_along+V_drifter_along;
                    
                    u_drifter_origin_1=u_drifter_origin*sind(beta)-v_drifter_origin*cosd(beta);
                    v_drifter_origin_1=u_drifter_origin*cosd(beta)+v_drifter_origin*sind(beta);
                    
                    u_drifter_geo_1=u_drifter_geo*sind(beta)-v_drifter_geo*cosd(beta);
                    v_drifter_geo_1=u_drifter_geo*cosd(beta)+v_drifter_geo*sind(beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',DATE_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LON_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LAT_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'%15.4f',V1);
                        fprintf(fid_write,'%15.4f',U1);
                        fprintf(fid_write,'%15.4f',v_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',u_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',v_drifter_geo_1);
                        fprintf(fid_write,'%15.4f',u_drifter_geo_1);
                        fprintf(fid_write,'%15d',dateTime_tc(p));
                        fprintf(fid_write,'%15.4f',Lon_tc(p));
                        fprintf(fid_write,'%15.4f',Lat_tc(p));
                        fprintf(fid_write,'%15d',Vmax_tc(p));
                        fprintf(fid_write,'%15d',Rmax_tc(p));
                        fprintf(fid_write,'\n');
                        
                        tc_name=[tc_name;str2num(file_tc(1:6))];
                    end
                end
            end
        end
        clear file_tc fid_tc data_tc dateTime_tc Lat_tc Lon_tc Vmax_tc Rmax_tc
    end
end
fclose('all');
save([path_out,'na-tcName_TS1_19792020.mat'],'tc_name');



% NEP
clear;clc;
path_drifter='/datas/ageostrophic u_v/';
path_tc='/datas/Hurdat/Hurdat_nep-intensity-bySSS_1979-2020_step2/';
path_out = '/datas/current in storm-coordinate system/';

% ageostrophic flow
load([path_drifter,'nep_ageostrophicFlow_19792020.mat']);
x=[double(DATE_drifter),LON_drifter,LAT_drifter];
[~,idx]=unique(x,'rows');
DATE_drifter=DATE_drifter(idx);
LAT_drifter=LAT_drifter(idx);
LON_drifter=LON_drifter(idx);
Ue=Ue(idx);
Ve=Ve(idx);
U_drifter_origin=U_drifter_origin(idx);
V_drifter_origin=V_drifter_origin(idx);
U_drifter_geo=U_drifter_geo(idx);
V_drifter_geo=V_drifter_geo(idx);
clear x idx

% TC
folders_tc=dir(path_tc);

fid_write = fopen([path_out,'nep-ageostrophicFlowInStormCoordinateSystem_withinTC7Rmax_TS1_19792020.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s',...
    'date_drifter','lon_drifter','lat_drifter','r_along','r_cross','Ve','Ue','Vorigin',...
    'Uorigin','Vgeo','Ugeo','date_tc','lon_tc','lat_tc','Vmax','Rmax');
fprintf(fid_write,'\n');

tc_name=[];
for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%d%d%d%d%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Vmax_tc=data_tc{4};
        Rmax_tc=double(data_tc{9});
        pos=find(Lon_tc<180);
        dateTime_tc(pos)=[];
        Lat_tc(pos)=[];
        Lon_tc(pos)=[];
        Vmax_tc(pos)=[];
        Rmax_tc(pos)=[];
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==DATE_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                if (Rmax==0)
                    disp(1);
                    continue
                end
                
                for q=1:length(idx)
                    % rotate r
                    lat_drifter=LAT_drifter(idx(q));
                    lon_drifter=LON_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    % roate u & v
                    U_drifter = Ue(idx(q));
                    V_drifter = Ve(idx(q));
                    u_drifter_origin=U_drifter_origin(idx(q));
                    v_drifter_origin=V_drifter_origin(idx(q));
                    u_drifter_geo=U_drifter_geo(idx(q));
                    v_drifter_geo=V_drifter_geo(idx(q));
                    
                    U_drifter_across=U_drifter*sind(beta);
                    V_drifter_across=-V_drifter*cosd(beta);
                    U_drifter_along=U_drifter*cosd(beta);
                    V_drifter_along=V_drifter*sind(beta);
                    U1=U_drifter_across+V_drifter_across;
                    V1=U_drifter_along+V_drifter_along;
                    
                    u_drifter_origin_1=u_drifter_origin*sind(beta)-v_drifter_origin*cosd(beta);
                    v_drifter_origin_1=u_drifter_origin*cosd(beta)+v_drifter_origin*sind(beta);
                    
                    u_drifter_geo_1=u_drifter_geo*sind(beta)-v_drifter_geo*cosd(beta);
                    v_drifter_geo_1=u_drifter_geo*cosd(beta)+v_drifter_geo*sind(beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',DATE_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LON_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LAT_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'%15.4f',V1);
                        fprintf(fid_write,'%15.4f',U1);
                        fprintf(fid_write,'%15.4f',v_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',u_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',v_drifter_geo_1);
                        fprintf(fid_write,'%15.4f',u_drifter_geo_1);
                        fprintf(fid_write,'%15d',dateTime_tc(p));
                        fprintf(fid_write,'%15.4f',Lon_tc(p));
                        fprintf(fid_write,'%15.4f',Lat_tc(p));
                        fprintf(fid_write,'%15d',Vmax_tc(p));
                        fprintf(fid_write,'%15d',Rmax_tc(p));
                        fprintf(fid_write,'\n');
                        
                        tc_name=[tc_name;str2num(file_tc(1:6))];
                    end
                end
            end
        end
        clear file_tc fid_tc data_tc dateTime_tc Lat_tc Lon_tc Vmax_tc Rmax_tc
    end
end
fclose('all');
save([path_out,'nep-tcName_TS1_19792020.mat'],'tc_name');



% NIO
clear;clc;
path_drifter='/datas/ageostrophic u_v/';
path_tc='/datas/JTWC/jtwc-nio/jtwc-nio-intensity-bySSS_1979-2020_step2/';
path_out = '/datas/current in storm-coordinate system/';

% ageostrophic flow
load([path_drifter,'nio_ageostrophicFlow_19792020.mat']);
x=[double(DATE_drifter),LON_drifter,LAT_drifter];
[~,idx]=unique(x,'rows');
DATE_drifter=DATE_drifter(idx);
LAT_drifter=LAT_drifter(idx);
LON_drifter=LON_drifter(idx);
Ue=Ue(idx);
Ve=Ve(idx);
U_drifter_origin=U_drifter_origin(idx);
V_drifter_origin=V_drifter_origin(idx);
U_drifter_geo=U_drifter_geo(idx);
V_drifter_geo=V_drifter_geo(idx);
clear x idx

% TC
folders_tc=dir(path_tc);

fid_write = fopen([path_out,'nio-ageostrophicFlowInStormCoordinateSystem_withinTC7Rmax_TS1_19792020.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s',...
    'date_drifter','lon_drifter','lat_drifter','r_along','r_cross','Ve','Ue','Vorigin',...
    'Uorigin','Vgeo','Ugeo','date_tc','lon_tc','lat_tc','Vmax','Rmax');
fprintf(fid_write,'\n');

tc_name=[];
for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%s%s%s%s%s%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Vmax_tc=data_tc{4};
        Rmax_tc=double(data_tc{10});
        pos=find(Lon_tc<30 | Lon_tc>100);
        dateTime_tc(pos)=[];
        Lat_tc(pos)=[];
        Lon_tc(pos)=[];
        Vmax_tc(pos)=[];
        Rmax_tc(pos)=[];
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==DATE_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                if (Rmax==0)
                    disp(1);
                    continue
                end
                
                for q=1:length(idx)
                    % rotate r
                    lat_drifter=LAT_drifter(idx(q));
                    lon_drifter=LON_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    % roate u & v
                    U_drifter = Ue(idx(q));
                    V_drifter = Ve(idx(q));
                    u_drifter_origin=U_drifter_origin(idx(q));
                    v_drifter_origin=V_drifter_origin(idx(q));
                    u_drifter_geo=U_drifter_geo(idx(q));
                    v_drifter_geo=V_drifter_geo(idx(q));
                    
                    U_drifter_across=U_drifter*sind(beta);
                    V_drifter_across=-V_drifter*cosd(beta);
                    U_drifter_along=U_drifter*cosd(beta);
                    V_drifter_along=V_drifter*sind(beta);
                    U1=U_drifter_across+V_drifter_across;
                    V1=U_drifter_along+V_drifter_along;
                    
                    u_drifter_origin_1=u_drifter_origin*sind(beta)-v_drifter_origin*cosd(beta);
                    v_drifter_origin_1=u_drifter_origin*cosd(beta)+v_drifter_origin*sind(beta);
                    
                    u_drifter_geo_1=u_drifter_geo*sind(beta)-v_drifter_geo*cosd(beta);
                    v_drifter_geo_1=u_drifter_geo*cosd(beta)+v_drifter_geo*sind(beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',DATE_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LON_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LAT_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'%15.4f',V1);
                        fprintf(fid_write,'%15.4f',U1);
                        fprintf(fid_write,'%15.4f',v_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',u_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',v_drifter_geo_1);
                        fprintf(fid_write,'%15.4f',u_drifter_geo_1);
                        fprintf(fid_write,'%15d',dateTime_tc(p));
                        fprintf(fid_write,'%15.4f',Lon_tc(p));
                        fprintf(fid_write,'%15.4f',Lat_tc(p));
                        fprintf(fid_write,'%15d',Vmax_tc(p));
                        fprintf(fid_write,'%15d',Rmax_tc(p));
                        fprintf(fid_write,'\n');
                        
                        tc_name=[tc_name;str2num(file_tc(1:6))];
                    end
                end
            end
        end
        clear file_tc fid_tc data_tc dateTime_tc Lat_tc Lon_tc Vmax_tc Rmax_tc
    end
end
fclose('all');
save([path_out,'nio-tcName_TS1_19792020.mat'],'tc_name');



% NWP
clear;clc;
path_drifter='/datas/ageostrophic u_v/';
path_tc='/datas/JTWC/jtwc-intensity-bySSS_1979-2020_step2/';
path_out = '/datas/current in storm-coordinate system/';

% ageostrophic flow
load([path_drifter,'nwp_ageostrophicFlow_19792020.mat']);
x=[double(DATE_drifter),LON_drifter,LAT_drifter];
[~,idx]=unique(x,'rows');
DATE_drifter=DATE_drifter(idx);
LAT_drifter=LAT_drifter(idx);
LON_drifter=LON_drifter(idx);
Ue=Ue(idx);
Ve=Ve(idx);
U_drifter_origin=U_drifter_origin(idx);
V_drifter_origin=V_drifter_origin(idx);
U_drifter_geo=U_drifter_geo(idx);
V_drifter_geo=V_drifter_geo(idx);
clear x idx

% TC
folders_tc=dir(path_tc);

fid_write = fopen([path_out,'nwp-ageostrophicFlowInStormCoordinateSystem_withinTC7Rmax_TS1_19792020.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s',...
    'date_drifter','lon_drifter','lat_drifter','r_along','r_cross','Ve','Ue','Vorigin',...
    'Uorigin','Vgeo','Ugeo','date_tc','lon_tc','lat_tc','Vmax','Rmax');
fprintf(fid_write,'\n');

tc_name=[];
for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%s%s%s%s%s%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Vmax_tc=data_tc{4};
        Rmax_tc=double(data_tc{10});
        pos=find(Lon_tc<100 | Lon_tc>180);
        dateTime_tc(pos)=[];
        Lat_tc(pos)=[];
        Lon_tc(pos)=[];
        Vmax_tc(pos)=[];
        Rmax_tc(pos)=[];
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==DATE_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                if (Rmax==0)
                    disp(1);
                    continue
                end
                
                for q=1:length(idx)
                    % rotate r
                    lat_drifter=LAT_drifter(idx(q));
                    lon_drifter=LON_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    % roate u & v
                    U_drifter = Ue(idx(q));
                    V_drifter = Ve(idx(q));
                    u_drifter_origin=U_drifter_origin(idx(q));
                    v_drifter_origin=V_drifter_origin(idx(q));
                    u_drifter_geo=U_drifter_geo(idx(q));
                    v_drifter_geo=V_drifter_geo(idx(q));
                    
                    U_drifter_across=U_drifter*sind(beta);
                    V_drifter_across=-V_drifter*cosd(beta);
                    U_drifter_along=U_drifter*cosd(beta);
                    V_drifter_along=V_drifter*sind(beta);
                    U1=U_drifter_across+V_drifter_across;
                    V1=U_drifter_along+V_drifter_along;
                    
                    u_drifter_origin_1=u_drifter_origin*sind(beta)-v_drifter_origin*cosd(beta);
                    v_drifter_origin_1=u_drifter_origin*cosd(beta)+v_drifter_origin*sind(beta);
                    
                    u_drifter_geo_1=u_drifter_geo*sind(beta)-v_drifter_geo*cosd(beta);
                    v_drifter_geo_1=u_drifter_geo*cosd(beta)+v_drifter_geo*sind(beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',DATE_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LON_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LAT_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'%15.4f',V1);
                        fprintf(fid_write,'%15.4f',U1);
                        fprintf(fid_write,'%15.4f',v_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',u_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',v_drifter_geo_1);
                        fprintf(fid_write,'%15.4f',u_drifter_geo_1);
                        fprintf(fid_write,'%15d',dateTime_tc(p));
                        fprintf(fid_write,'%15.4f',Lon_tc(p));
                        fprintf(fid_write,'%15.4f',Lat_tc(p));
                        fprintf(fid_write,'%15d',Vmax_tc(p));
                        fprintf(fid_write,'%15d',Rmax_tc(p));
                        fprintf(fid_write,'\n');
                        
                        tc_name=[tc_name;str2num(file_tc(1:6))];
                    end
                end
            end
        end
        clear file_tc fid_tc data_tc dateTime_tc Lat_tc Lon_tc Vmax_tc Rmax_tc
    end
end
fclose('all');
save([path_out,'nwp-tcName_TS1_19792020.mat'],'tc_name');



% SIO
clear;clc;
path_drifter='/datas/ageostrophic u_v/';
path_tc='/datas/JTWC/jtwc-sh/jtwc-sh-intensity-bySSS_1979-2020_step2/';
path_out = '/datas/current in storm-coordinate system/';

% ageostrophic flow
load([path_drifter,'sio_ageostrophicFlow_19792020.mat']);
x=[double(DATE_drifter),LON_drifter,LAT_drifter];
[~,idx]=unique(x,'rows');
DATE_drifter=DATE_drifter(idx);
LAT_drifter=LAT_drifter(idx);
LON_drifter=LON_drifter(idx);
Ue=Ue(idx);
Ve=Ve(idx);
U_drifter_origin=U_drifter_origin(idx);
V_drifter_origin=V_drifter_origin(idx);
U_drifter_geo=U_drifter_geo(idx);
V_drifter_geo=V_drifter_geo(idx);
clear x idx

% TC
folders_tc=dir(path_tc);

fid_write = fopen([path_out,'sio-ageostrophicFlowInStormCoordinateSystem_withinTC7Rmax_TS1_19792020.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s',...
    'date_drifter','lon_drifter','lat_drifter','r_along','r_cross','Ve','Ue','Vorigin',...
    'Uorigin','Vgeo','Ugeo','date_tc','lon_tc','lat_tc','Vmax','Rmax');
fprintf(fid_write,'\n');

tc_name=[];
for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%s%s%s%s%s%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Vmax_tc=data_tc{4};
        Rmax_tc=double(data_tc{10});
        pos=find(Lon_tc<20 | Lon_tc>135);
        dateTime_tc(pos)=[];
        Lat_tc(pos)=[];
        Lon_tc(pos)=[];
        Vmax_tc(pos)=[];
        Rmax_tc(pos)=[];
        clear pos
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==DATE_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                if (Rmax==0)
                    continue
                end
                
                for q=1:length(idx)
                    % rotate r
                    lat_drifter=LAT_drifter(idx(q));
                    lon_drifter=LON_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    % roate u & v
                    U_drifter = Ue(idx(q));
                    V_drifter = Ve(idx(q));
                    u_drifter_origin=U_drifter_origin(idx(q));
                    v_drifter_origin=V_drifter_origin(idx(q));
                    u_drifter_geo=U_drifter_geo(idx(q));
                    v_drifter_geo=V_drifter_geo(idx(q));
                    
                    U_drifter_across=U_drifter*sind(beta);
                    V_drifter_across=-V_drifter*cosd(beta);
                    U_drifter_along=U_drifter*cosd(beta);
                    V_drifter_along=V_drifter*sind(beta);
                    U1=U_drifter_across+V_drifter_across;
                    V1=U_drifter_along+V_drifter_along;
                    
                    u_drifter_origin_1=u_drifter_origin*sind(beta)-v_drifter_origin*cosd(beta);
                    v_drifter_origin_1=u_drifter_origin*cosd(beta)+v_drifter_origin*sind(beta);
                    
                    u_drifter_geo_1=u_drifter_geo*sind(beta)-v_drifter_geo*cosd(beta);
                    v_drifter_geo_1=u_drifter_geo*cosd(beta)+v_drifter_geo*sind(beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',DATE_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LON_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LAT_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'%15.4f',V1);
                        fprintf(fid_write,'%15.4f',U1);
                        fprintf(fid_write,'%15.4f',v_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',u_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',v_drifter_geo_1);
                        fprintf(fid_write,'%15.4f',u_drifter_geo_1);
                        fprintf(fid_write,'%15d',dateTime_tc(p));
                        fprintf(fid_write,'%15.4f',Lon_tc(p));
                        fprintf(fid_write,'%15.4f',Lat_tc(p));
                        fprintf(fid_write,'%15d',Vmax_tc(p));
                        fprintf(fid_write,'%15d',Rmax_tc(p));
                        fprintf(fid_write,'\n');
                        
                        tc_name=[tc_name;str2num(file_tc(1:6))];
                    end
                end
            end
        end
        clear file_tc fid_tc data_tc dateTime_tc Lat_tc Lon_tc Vmax_tc Rmax_tc
    end
end
fclose('all');
save([path_out,'sio-tcName_TS1_19792020.mat'],'tc_name');



% SP
clear;clc;
path_drifter='/datas/ageostrophic u_v/';
path_tc='/datas/JTWC/jtwc-sh/jtwc-sh-intensity-bySSS_1979-2020_step2/';
path_out = '/datas/current in storm-coordinate system/';

% ageostrophic flow
load([path_drifter,'sp_ageostrophicFlow_19792020.mat']);
x=[double(DATE_drifter),LON_drifter,LAT_drifter];
[~,idx]=unique(x,'rows');
DATE_drifter=DATE_drifter(idx);
LAT_drifter=LAT_drifter(idx);
LON_drifter=LON_drifter(idx);
Ue=Ue(idx);
Ve=Ve(idx);
U_drifter_origin=U_drifter_origin(idx);
V_drifter_origin=V_drifter_origin(idx);
U_drifter_geo=U_drifter_geo(idx);
V_drifter_geo=V_drifter_geo(idx);
clear x idx

% TC
folders_tc=dir(path_tc);

fid_write = fopen([path_out,'sp-ageostrophicFlowInStormCoordinateSystem_withinTC7Rmax_TS1_19792020.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s',...
    'date_drifter','lon_drifter','lat_drifter','r_along','r_cross','Ve','Ue','Vorigin',...
    'Uorigin','Vgeo','Ugeo','date_tc','lon_tc','lat_tc','Vmax','Rmax');
fprintf(fid_write,'\n');

tc_name=[];
for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%s%s%s%s%s%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Vmax_tc=data_tc{4};
        Rmax_tc=double(data_tc{10});
        pos=find(Lon_tc<135 | Lon_tc>290);
        dateTime_tc(pos)=[];
        Lat_tc(pos)=[];
        Lon_tc(pos)=[];
        Vmax_tc(pos)=[];
        Rmax_tc(pos)=[];
        clear pos
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==DATE_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                if (Rmax==0)
                    continue
                end
                
                for q=1:length(idx)
                    % rotate r
                    lat_drifter=LAT_drifter(idx(q));
                    lon_drifter=LON_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    % roate u & v
                    U_drifter = Ue(idx(q));
                    V_drifter = Ve(idx(q));
                    u_drifter_origin=U_drifter_origin(idx(q));
                    v_drifter_origin=V_drifter_origin(idx(q));
                    u_drifter_geo=U_drifter_geo(idx(q));
                    v_drifter_geo=V_drifter_geo(idx(q));
                    
                    U_drifter_across=U_drifter*sind(beta);
                    V_drifter_across=-V_drifter*cosd(beta);
                    U_drifter_along=U_drifter*cosd(beta);
                    V_drifter_along=V_drifter*sind(beta);
                    U1=U_drifter_across+V_drifter_across;
                    V1=U_drifter_along+V_drifter_along;
                    
                    u_drifter_origin_1=u_drifter_origin*sind(beta)-v_drifter_origin*cosd(beta);
                    v_drifter_origin_1=u_drifter_origin*cosd(beta)+v_drifter_origin*sind(beta);
                    
                    u_drifter_geo_1=u_drifter_geo*sind(beta)-v_drifter_geo*cosd(beta);
                    v_drifter_geo_1=u_drifter_geo*cosd(beta)+v_drifter_geo*sind(beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',DATE_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LON_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',LAT_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'%15.4f',V1);
                        fprintf(fid_write,'%15.4f',U1);
                        fprintf(fid_write,'%15.4f',v_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',u_drifter_origin_1);
                        fprintf(fid_write,'%15.4f',v_drifter_geo_1);
                        fprintf(fid_write,'%15.4f',u_drifter_geo_1);
                        fprintf(fid_write,'%15d',dateTime_tc(p));
                        fprintf(fid_write,'%15.4f',Lon_tc(p));
                        fprintf(fid_write,'%15.4f',Lat_tc(p));
                        fprintf(fid_write,'%15d',Vmax_tc(p));
                        fprintf(fid_write,'%15d',Rmax_tc(p));
                        fprintf(fid_write,'\n');
                        
                        tc_name=[tc_name;str2num(file_tc(1:6))];
                    end
                end
            end
        end
        clear file_tc fid_tc data_tc dateTime_tc Lat_tc Lon_tc Vmax_tc Rmax_tc
    end
end
fclose('all');
save([path_out,'sp-tcName_TS1_19792020.mat'],'tc_name');




