% figure 2 code 5


clear;clc;
path_drifter='/datas/current in storm-coordinate system/';
path_out = '/datas/current in storm-coordinate system/';

files = dir([path_drifter,'*ageostrophicFlowInStormCoordinateSystem_withinTC7Rmax_TS1_19792020.dat']);
files_tcname=dir([path_drifter,'*tcName_TS1_19792020.mat']);

years=1991:1:2020;

num_effective=nan(length(years),length(files_tcname));
for i=1:length(files)  % na,nep,nio,nwp,sio,sp
    file=files(i).name;
    fid=fopen([path_drifter,file],'r');
    data=textscan(fid,'%15d%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15d%15.4f%15.4f%15d%15d','headerlines',1);
    fclose(fid);
    datetime_drifter=data{1};
    datetimestr_drifter=num2str(datetime_drifter);
    year_drifter=str2num(datetimestr_drifter(:,1:4));
    r_along=data{4};
    r_cross=data{5};
    V_drifter=data{6}.*100; % cm/s
    U_drifter=data{7}.*100; % cm/s
    datetime_tc=data{12};
    datetimestr_tc=num2str(datetime_tc);
    day_tc=datenum(str2num(datetimestr_tc(:,1:4)),str2num(datetimestr_tc(:,5:6)),str2num(datetimestr_tc(:,7:8)), ...
        str2num(datetimestr_tc(:,9:10)),zeros(length(datetimestr_tc),1),zeros(length(datetimestr_tc),1));
    lon_tc=data{13};
    lat_tc=data{14};
    clear file fid data datetime_drifter datetimestr_drifter datetime_tc datetimestr_tc
    
    load([path_drifter,files_tcname(i).name]);
    
    idx=sqrt(r_along.^2+r_cross.^2)<=7 & sqrt(U_drifter.^2+V_drifter.^2)<500;
    year_drifter=year_drifter(idx);
    day_tc=day_tc(idx);
    lon_tc=lon_tc(idx);
    lat_tc=lat_tc(idx);
    tc_name=tc_name(idx);
    clear idx r_along r_cross V_drifter U_drifter
    
    for j=1:length(years)
        pos=find(year_drifter==years(j));
        day_tc1=day_tc(pos);
        lon_tc1=lon_tc(pos);
        lon_tc1(lon_tc1>180)=lon_tc1(lon_tc1>180)-360;
        lat_tc1=lat_tc(pos);
        tc_name1=tc_name(pos);
        tc_name1_uni=unique(tc_name1);
        clear pos
        
        [tc_name1,idx]=sort(tc_name1);
        day_tc1=day_tc1(idx);
        lon_tc1=lon_tc1(idx);
        lat_tc1=lat_tc1(idx);
        clear idx
        
        tc_cen=[day_tc1,lat_tc1,lon_tc1];
        
        num=ones(size(tc_name1_uni,1),1);
        for m=1:size(tc_name1_uni,1)
            idx=tc_name1_uni(m)==tc_name1;
            tc_cen_1=tc_cen(idx,:);
            
            if (size(tc_cen_1,1)==1)
                num(m)=num(m)+1;
                clear idx tc_cen_1
                continue
            end
            
            s=1;
            for n=2:size(tc_cen_1,1)
                diff_t=tc_cen_1(n,1)-tc_cen_1(s,1);
                [dist,~]=sw_dist([tc_cen_1(n,2),tc_cen_1(s,2)],[tc_cen_1(n,3),tc_cen_1(s,3)],'km');
                
                if (diff_t>=10 || dist>=500)
                    num(m)=num(m)+1;
                    
                    s=n;
                end
                clear diff_t dist
            end
            clear idx tc_cen_1 s n
        end
        
        num_effective(j,i)=sum(num);
        clear num m
    end
end
save([path_out,'effective number observations.mat'],'num_effective');




