% paper 1中 figure 2 plot


clear;clc;
path_in='/datas/fig2/';
path_figure='/figures/fig2/';


% 1
files=dir([path_in,'*ageostrophicFlowInStormCoordinateSystem_withinTC7Rmax_TS1_19792020.dat']);

load([path_in,'effective number observations.mat']);

years=1991:1:2020;

yearly_drifterspeed_all=NaN(length(years),length(files));
yearly_drifterspeed_std_all=NaN(length(years),length(files));
num_Yearlydrifters_all=NaN(length(years),length(files));
trend_yearly_drifterspeed_all=NaN(length(years),length(files));

year_drifter_all=[];
U_drifter_all=[];
V_drifter_all=[];
for i=1:length(files)
    file=files(i).name;
    fid=fopen([path_in,file],'r');
    data=textscan(fid,'%15d%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15d%15.4f%15.4f%15d%15d','headerlines',1);
    fclose(fid);
    datetime_drifter=data{1};
    datetimestr_drifter=num2str(datetime_drifter);
    year_drifter=str2num(datetimestr_drifter(:,1:4));
    clear datetime_drifter datetimestr_drifter;
    r_along=data{4};
    r_cross=data{5};
    V_drifter=data{6}.*100;
    U_drifter=data{7}.*100;
    
    idx=sqrt(r_along.^2+r_cross.^2)<=7 & sqrt(U_drifter.^2+V_drifter.^2)<500;
    year_drifter=year_drifter(idx);
    V_drifter=V_drifter(idx);
    U_drifter=U_drifter(idx);
    
    year_drifter_all=[year_drifter_all;year_drifter];
    U_drifter_all=[U_drifter_all;U_drifter];
    V_drifter_all=[V_drifter_all;V_drifter];
    
    yearly_drifterspeed=NaN(length(years),1);
    yearly_drifterspeed_std=NaN(length(years),1);
    num_Yearlydrifters=NaN(length(years),1);
    for j = 1:length(years)
        pos = find(year_drifter==years(j));
        V_drifter1 = V_drifter(pos);
        U_drifter1 = U_drifter(pos);
        
        speed=sqrt(U_drifter1.^2+V_drifter1.^2);
        yearly_drifterspeed(j) = nanmean(speed);
        yearly_drifterspeed_std(j)=nanstd(speed)/sqrt(num_effective(j,i));
        num_Yearlydrifters(j)=length(speed);
    end
    yearly_drifterspeed_all(:,i)=yearly_drifterspeed;
    yearly_drifterspeed_std_all(:,i)=yearly_drifterspeed_std;
    num_Yearlydrifters_all(:,i)=num_Yearlydrifters;
    
    trend_yearly_drifterspeed=NaN(length(years),1);
    tf=find(~isnan(yearly_drifterspeed));
    detrend_yearly_drifterspeed=detrend(yearly_drifterspeed(tf));
    trend_yearly_drifterspeed(tf)=yearly_drifterspeed(tf)-detrend_yearly_drifterspeed;
    idx_nan=setdiff(1:length(years),tf);
    trend_yearly_drifterspeed(idx_nan)=NaN;
    trend_yearly_drifterspeed_all(:,i)=trend_yearly_drifterspeed;
end

globalmean_yearly_drifterspeed=NaN(length(years),1);
globalmean_yearly_drifterspeed_std=NaN(length(years),1);
globalmean_num_Yearlydrifters=NaN(length(years),1);
for j=1:length(years)
    pos = find(year_drifter_all==years(j));
    V_drifter1 = V_drifter_all(pos);
    U_drifter1 = U_drifter_all(pos);
    
    speed=sqrt(U_drifter1.^2+V_drifter1.^2);
    globalmean_yearly_drifterspeed(j) = nanmean(speed);
    globalmean_yearly_drifterspeed_std(j)=nanstd(speed)/sqrt(sum(num_effective(j,:)));
    globalmean_num_Yearlydrifters(j)=length(speed);
end
trend_globalmean_yearly_drifterspeed=NaN(length(years),1);
tf=find(~isnan(globalmean_yearly_drifterspeed));
detrend_globalmean_yearly_drifterspeed=detrend(globalmean_yearly_drifterspeed(tf));
trend_globalmean_yearly_drifterspeed(tf)=globalmean_yearly_drifterspeed(tf)-detrend_globalmean_yearly_drifterspeed;
idx_nan=setdiff(1:length(years),tf);
trend_globalmean_yearly_drifterspeed(idx_nan)=NaN;

% statistical analysis of the significance of the fitted line
s=nan(1,6);
c=nan(2,6);
p=nan(1,6);
for i=1:6
    [B,BINT,~,~,STATS] = regress(yearly_drifterspeed_all(:,i),[years',ones(length(years),1)]);
    s(i)=round(B(1),2);
    c(:,i)=BINT(1,:)';
    p(i)=STATS(3);
    clear B BINT STATS
end
[B,BINT,~,~,STATS] = regress(globalmean_yearly_drifterspeed,[years',ones(length(years),1)]);
s(7)=round(B(1),2);
c(:,7)=BINT(1,:)';
p(7)=STATS(3);
clear B BINT STATS


% 2
% TC best track Vmax
load ([path_in,'TC_global-withTCspeed.mat'],'date_tc_all','Vmax_tc_all');
datestr_tc_all=num2str(date_tc_all);
year_tc_all=str2num(datestr_tc_all(:,1:4));
Vmax_tc_all=double(Vmax_tc_all);
idx= year_tc_all>=1991 & year_tc_all<=2020 & Vmax_tc_all>0 & Vmax_tc_all<=82;  % 1991-2020的弱台风
year_tc_all=year_tc_all(idx);
Vmax_tc_all=Vmax_tc_all(idx);
clear datestr_tc_all date_tc_all idx

% drifter current derived Vmax
load([path_in,'uv_within7Rmax_atDrifter_ideal_TS1_yearly.mat'],'mean_speed');
for i=1:size(mean_speed,3)
    mean_speed_atDrifter(:,:,i)=smooth2a(mean_speed(:,:,i),1,1);
end
clear mean_speed i
for i=1:size(mean_speed_atDrifter,3)
    [rr(i),cc(i)]=find(mean_speed_atDrifter(:,:,i)==max(max(mean_speed_atDrifter(:,:,i))));
end
for i=1:size(mean_speed_atDrifter,3)
    Vmax_byDrifter(i)=ceil(mean_speed_atDrifter(rr(i),cc(i),i));
end
clear i rr cc mean_speed_atDrifter

years=1991:1:2020;
PDIbyTCVmax_yearly=nan(length(years),1);
PDIbyDrifterVmax_yearly=nan(length(years),1);
for i=1:length(years)
    idx=find(year_tc_all==years(i));
    num_tc=length(idx);
    
    % PDI by TC best track Vmax
    Vmax=Vmax_tc_all(idx);
    PDIbyTCVmax_1year=0;
    for m=1:num_tc
        Vmax_1=Vmax(m);
        pdi=power(Vmax_1*0.5144,3)*(6*3600);
        PDIbyTCVmax_1year=PDIbyTCVmax_1year+pdi;
    end
    PDIbyTCVmax_yearly(i)=PDIbyTCVmax_1year;
    
    % PDI by drifter current derived Vmax
    PDIbyDrifterVmax_1year=0;
    for m=1:num_tc
        pdi=power(Vmax_byDrifter(i),3)*(6*3600);
        PDIbyDrifterVmax_1year=PDIbyDrifterVmax_1year+pdi;
    end
    PDIbyDrifterVmax_yearly(i)=PDIbyDrifterVmax_1year;
end

PDIbyTCVmax_yearly_1=nan(length(years),1);
PDIbyTCVmax_yearly_2=nan(length(years),1);
for k=2:length(years)-1
    PDIbyTCVmax_yearly_1(k)=0.25*(PDIbyTCVmax_yearly(k-1)+PDIbyTCVmax_yearly(k+1))+0.5*PDIbyTCVmax_yearly(k);
end
PDIbyTCVmax_yearly_1(1)=PDIbyTCVmax_yearly(1);
PDIbyTCVmax_yearly_1(end)=PDIbyTCVmax_yearly(end);
for k=2:length(years)-1
    PDIbyTCVmax_yearly_2(k)=0.25*(PDIbyTCVmax_yearly_1(k-1)+ PDIbyTCVmax_yearly_1(k+1))+0.5*PDIbyTCVmax_yearly_1(k);
end
PDIbyTCVmax_yearly_2(1)=PDIbyTCVmax_yearly(1);
PDIbyTCVmax_yearly_2(end)=PDIbyTCVmax_yearly(end);

PDIbyDrifterVmax_yearly_1=nan(length(years),1);
PDIbyDrifterVmax_yearly_2=nan(length(years),1);
for k=2:length(years)-1
    PDIbyDrifterVmax_yearly_1(k)=0.25*(PDIbyDrifterVmax_yearly(k-1)+PDIbyDrifterVmax_yearly(k+1))+0.5*PDIbyDrifterVmax_yearly(k);
end
PDIbyDrifterVmax_yearly_1(1)=PDIbyDrifterVmax_yearly(1);
PDIbyDrifterVmax_yearly_1(end)=PDIbyDrifterVmax_yearly(end);
for k=2:length(years)-1
    PDIbyDrifterVmax_yearly_2(k)=0.25*(PDIbyDrifterVmax_yearly_1(k-1)+ PDIbyDrifterVmax_yearly_1(k+1))+0.5*PDIbyDrifterVmax_yearly_1(k);
end
PDIbyDrifterVmax_yearly_2(1)=PDIbyDrifterVmax_yearly(1);
PDIbyDrifterVmax_yearly_2(end)=PDIbyDrifterVmax_yearly(end);



% plot
f=figure;
set(f,'unit','centimeters','position',[5,5,25,25]);
% global mean
g1=axes('position',[0.15 0.19 0.7 0.13]);
plot(1:length(years),globalmean_yearly_drifterspeed,'linestyle','-','color','k','linewidth',0.5);
hold on
plot(1:length(years),trend_globalmean_yearly_drifterspeed,'linestyle','--','color','k','linewidth',1);
errorbar(1:length(years),globalmean_yearly_drifterspeed,globalmean_yearly_drifterspeed_std,'linestyle',':','color','k','linewidth',0.5);
g1.XAxis.Visible='on';
set(gca,'xlim',[1 length(years)],'ylim',[22 43]);
set(gca,'xtick',[1,5,10,15,20,25,30],'xticklabel',[]);
set(gca,'ytick',25:5:40,'yticklabel',25:5:40);
set(gca,'fontname','Arial','fontunits','point','fontsize',7,'xminortick','off');
text(26.5,26,'Global','fontname','Arial','fontunits','point','fontsize',7,'color','k','fontweight','bold');
text(2.1,39.5,['s=',num2str(round(s(7),2),'%3.2f'),'\pm',num2str(round((c(2,7)-c(1,7))/2,2),'%3.2f'),', p=',num2str(p(7),'%3.2e')],'fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');
% sp
g2=axes('position',[0.15 0.325 0.7 0.13]);
plot(1:length(years),yearly_drifterspeed_all(:,6),'linestyle','-','color','k','linewidth',0.5);
hold on
plot(1:length(years),trend_yearly_drifterspeed_all(:,6),'linestyle','--','color','k','linewidth',1);
errorbar(1:length(years),yearly_drifterspeed_all(:,6),yearly_drifterspeed_std_all(:,6),'linestyle','-','color','k','linewidth',0.5);
g2.XAxis.Visible='on';
set(gca,'xlim',[1 length(years)],'ylim',[13 67]);
set(gca,'xtick',[1,5,10,15,20,25,30],'xticklabel',[]);
set(gca,'ytick',15:15:60,'yticklabel',15:15:60);
set(gca,'fontname','Arial','fontunits','point','fontsize',7,'xminortick','off');
text(26.5,23,'SP','fontname','Arial','fontunits','point','fontsize',7,'color','k','fontweight','bold');
text(2.1,58,['s=',num2str(round(s(6),2),'%3.2f'),'\pm',num2str(round((c(2,6)-c(1,6))/2,2),'%3.2f'),', p=',num2str(p(6),'%3.2e')],'fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');
% si
g3=axes('position',[0.15 0.46 0.7 0.13]);
plot(1:length(years),yearly_drifterspeed_all(:,5),'linestyle','-','color','k','linewidth',0.5);
hold on
plot(1:length(years),trend_yearly_drifterspeed_all(:,5),'linestyle','--','color','k','linewidth',1);
errorbar(1:length(years),yearly_drifterspeed_all(:,5),yearly_drifterspeed_std_all(:,5),'linestyle','-','color','k','linewidth',0.5);
g3.XAxis.Visible='on';
set(gca,'xlim',[1 length(years)],'ylim',[13 67]);
set(gca,'xtick',[1,5,10,15,20,25,30],'xticklabel',[]);
set(gca,'ytick',15:15:60,'yticklabel',15:15:60);
set(gca,'fontname','Arial','fontunits','point','fontsize',7,'xminortick','off');
text(26.5,23,'SI','fontname','Arial','fontunits','point','fontsize',7,'color','k','fontweight','bold');
text(2.1,58,['s=',num2str(round(s(5),2),'%3.2f'),'\pm',num2str(round((c(2,5)-c(1,5))/2,2),'%3.2f'),', p=',num2str(p(5),'%3.2e')],'fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');
% nwp
g4=axes('position',[0.15 0.595 0.7 0.13]);
plot(1:length(years),yearly_drifterspeed_all(:,4),'linestyle','-','color','k','linewidth',0.5);
hold on
plot(1:length(years),trend_yearly_drifterspeed_all(:,4),'linestyle','--','color','k','linewidth',1);
errorbar(1:length(years),yearly_drifterspeed_all(:,4),yearly_drifterspeed_std_all(:,4),'linestyle','-','color','k','linewidth',0.5);
g4.XAxis.Visible='on';
set(gca,'xlim',[1 length(years)],'ylim',[11 52]);
set(gca,'xtick',[1,5,10,15,20,25,30],'xticklabel',[]);
set(gca,'ytick',15:10:45,'yticklabel',15:10:45);
set(gca,'fontname','Arial','fontunits','point','fontsize',7,'xminortick','off');
text(26.5,18,'NWP','fontname','Arial','fontunits','point','fontsize',7,'color','k','fontweight','bold');
text(2.1,46,['s=',num2str(round(s(4),2),'%3.2f'),'\pm',num2str(round((c(2,4)-c(1,4))/2,2),'%3.2f'),', p=',num2str(p(4),'%3.2e')],'fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');
% nep
g5=axes('position',[0.15 0.73 0.7 0.13]);
plot(1:length(years),yearly_drifterspeed_all(:,2),'linestyle','-','color','k','linewidth',0.5);
hold on
plot(1:length(years),trend_yearly_drifterspeed_all(:,2),'linestyle','--','color','k','linewidth',1);
errorbar(1:length(years),yearly_drifterspeed_all(:,2),yearly_drifterspeed_std_all(:,2),'linestyle','-','color','k','linewidth',0.5);
g5.XAxis.Visible='on';
set(gca,'xlim',[1 length(years)],'ylim',[11 52]);
set(gca,'xtick',[1,5,10,15,20,25,30],'xticklabel',[]);
set(gca,'ytick',15:10:45,'yticklabel',15:10:45);
set(gca,'fontname','Arial','fontunits','point','fontsize',7,'xminortick','off');
text(26.5,18,'NEP','fontname','Arial','fontunits','point','fontsize',7,'color','k','fontweight','bold');
text(2.1,46,['s=',num2str(round(s(2),2),'%3.2f'),'\pm',num2str(round((c(2,2)-c(1,2))/2,2),'%3.2f'),', p=',num2str(p(2),'%3.2e')],'fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');
% na
g6=axes('position',[0.15 0.865 0.7 0.13]);
plot(1:length(years),yearly_drifterspeed_all(:,1),'linestyle','-','color','k','linewidth',0.5);
hold on
plot(1:length(years),trend_yearly_drifterspeed_all(:,1),'linestyle','--','color','k','linewidth',1);
errorbar(1:length(years),yearly_drifterspeed_all(:,1),yearly_drifterspeed_std_all(:,1),'linestyle','-','color','k','linewidth',0.5);
g6.XAxis.Visible='on';
set(gca,'xlim',[1 length(years)],'ylim',[11 52]);
set(gca,'xtick',[1,5,10,15,20,25,30],'xticklabel',[]);
set(gca,'ytick',15:10:45,'yticklabel',15:10:45);
set(gca,'fontname','Arial','fontunits','point','fontsize',7,'xminortick','off');
text(26.5,18,'NA','fontname','Arial','fontunits','point','fontsize',7,'color','k','fontweight','bold');
text(2.1,46,['s=',num2str(round(s(1),2),'%3.2f'),'\pm',num2str(round((c(2,1)-c(1,1))/2,2),'%3.2f'),', p=',num2str(p(1),'%3.2e')],'fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');
% PDI
g7=axes('position',[0.15 0.055 0.7 0.13]);
set(g7,'YAxisLocation','left','ycolor','k');
hold on
h=plot(1:length(years),PDIbyTCVmax_yearly_2.*0.9e-12,'k-','linewidth',0.5);
hold on
hh=plot(1:length(years),PDIbyDrifterVmax_yearly_2.*0.9e-12,'k-','linewidth',2);
set(gca,'xlim',[1 length(years)],'ylim',[0.2 1]);
set(gca,'xtick',[1,5,10,15,20,25,30],'xticklabel',[]);
set(gca,'ytick',0.2:0.2:1,'yticklabel',0.2:.2:1);
set(gca,'fontname','Arial','fontunits','point','fontsize',7,'xminortick','off');
hhh=legend([h,hh],{'best track','drifter'});
set(hhh,'Location','north','orientation','horizontal','box','off','fontname','Arial','fontunits','point','fontsize',7);
ylabel('PDI (m^3/s^2)','color','k','fontname','Arial','fontunits','point','fontsize',7);
box on
g=axes('position',[0.15 0.055 0.7 0.94],'xtick',[],'ytick',[]);
set(g,'box','on','color','none');
set(g,'xlim',[1 length(years)]);
set(g,'xtick',[1,5,10,15,20,25,30],'xticklabel',[1991,1995,2000,2005,2010,2015,2020],'xticklabelrotation',0);
set(g,'fontname','Arial','fontunits','point','fontsize',7,'xminortick','of');
gg=text(14.5,-0.035,'Year','fontname','Arial','fontunits','point','fontsize',7);
text(-0.5,0.5,'Current speed (cm/s)','fontname','Arial','fontunits','point','fontsize',7,'rotation',90);
set(f,'RendererMode','manual','Renderer','painters');
print('-r600',[path_figure,'all basins-yearly mean drifterSpeed_TS1_1991-2020'],'-depsc');
close(f);




