% figure 3 code 2


% NA
clear;clc;
path_tc='/datas/Hurdat/Hurdat_at-intensity-bySSS_1979-2020_step2/';
path_drifter='/datas/drifterData/drifter_nio_sio_nwp_sp_nep_na-20220302/';
path_out='/datas/drifter_locations/';
folders_tc=dir(path_tc);

% drifter data
fileName_drifter='na_drifter_interpolated_1979-2021.dat';
fid_drifter=fopen([path_drifter,fileName_drifter]);
data_drifter=textscan(fid_drifter,'%d%d%10.4f%10.4f%10.4f%10.4f%10.4f%10.4f','headerlines',1);
% data:id,datetime,lat,lon,T,Ve,Vn,speed
fclose(fid_drifter);
dateTime_drifter=data_drifter{2};
Lat_drifter=data_drifter{3};
Lon_drifter=data_drifter{4};
Temp_drifter=data_drifter{5};
U_drifter=data_drifter{6};
V_drifter=data_drifter{7};
Spd_drifter=data_drifter{8};
idx=find(Lat_drifter>999 | Lon_drifter>999 | Temp_drifter>999 | U_drifter>999 | V_drifter>999 | Spd_drifter>999);
dateTime_drifter(idx)=[];
Lat_drifter(idx)=[];
Lon_drifter(idx)=[];
Temp_drifter(idx)=[];
U_drifter(idx)=[];
V_drifter(idx)=[];
Spd_drifter(idx)=[];

fid_write = fopen([path_out,'na_drifter within TC 7Rmax-TS1.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s','date_drifter','lat_drifter','lon_drifter', ...
    'Temp_drifter','u_drifter','v_drifter','spd_drifter','date_tc','lat_tc','lon_tc','r_along','r_cross');
fprintf(fid_write,'\n');

for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%d%d%d%d%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Rmax_tc=double(data_tc{9});
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==dateTime_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                
                for q=1:length(idx)
                    lat_drifter=Lat_drifter(idx(q));
                    lon_drifter=Lon_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',dateTime_drifter(idx(q)));  % datetime of drifter
                        fprintf(fid_write,'%15.4f',Lat_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Lon_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Temp_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',U_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',V_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Spd_drifter(idx(q)));
                        fprintf(fid_write,'%15d',dateTime_tc(p));  % datetime of tc
                        fprintf(fid_write,'%15.4f',lat_tc);
                        fprintf(fid_write,'%15.4f',lon_tc);
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'\n');
                    end
                end
            end
        end
    end
end
fclose(fid_write);



% NEP
clear;clc;
path_tc='/datas/Hurdat/Hurdat_nep-intensity-bySSS_1979-2020_step2/';
path_drifter='/datas/drifterData/drifter_nio_sio_nwp_sp_nep_na-20220302/';
path_out='/datas/drifter_locations/';
folders_tc=dir(path_tc);

% drifter data
fileName_drifter='nep_drifter_interpolated_1979-2021.dat';
fid_drifter=fopen([path_drifter,fileName_drifter]);
data_drifter=textscan(fid_drifter,'%d%d%10.4f%10.4f%10.4f%10.4f%10.4f%10.4f','headerlines',1);
% data:id,datetime,lat,lon,T,Ve,Vn,speed
fclose(fid_drifter);
dateTime_drifter=data_drifter{2};
Lat_drifter=data_drifter{3};
Lon_drifter=data_drifter{4};
Temp_drifter=data_drifter{5};
U_drifter=data_drifter{6};
V_drifter=data_drifter{7};
Spd_drifter=data_drifter{8};
idx=find(Lat_drifter>999 | Lon_drifter>999 | Temp_drifter>999 | U_drifter>999 | V_drifter>999 | Spd_drifter>999);
dateTime_drifter(idx)=[];
Lat_drifter(idx)=[];
Lon_drifter(idx)=[];
Temp_drifter(idx)=[];
U_drifter(idx)=[];
V_drifter(idx)=[];
Spd_drifter(idx)=[];

fid_write = fopen([path_out,'nep_drifter within TC 7Rmax-TS1.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s','date_drifter','lat_drifter','lon_drifter', ...
    'Temp_drifter','u_drifter','v_drifter','spd_drifter','date_tc','lat_tc','lon_tc','r_along','r_cross');
fprintf(fid_write,'\n');

for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%d%d%d%d%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Rmax_tc=double(data_tc{9});
        pos=find(Lon_tc<180);
        dateTime_tc(pos)=[];
        Lat_tc(pos)=[];
        Lon_tc(pos)=[];
        Rmax_tc(pos)=[];
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==dateTime_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                
                for q=1:length(idx)
                    lat_drifter=Lat_drifter(idx(q));
                    lon_drifter=Lon_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',dateTime_drifter(idx(q)));  % datetime of drifter
                        fprintf(fid_write,'%15.4f',Lat_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Lon_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Temp_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',U_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',V_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Spd_drifter(idx(q)));
                        fprintf(fid_write,'%15d',dateTime_tc(p));  % datetime of tc
                        fprintf(fid_write,'%15.4f',lat_tc);
                        fprintf(fid_write,'%15.4f',lon_tc);
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'\n');
                    end
                end
            end
        end
    end
end
fclose(fid_write);



% NIO
clear;clc;
path_tc='/datas/JTWC/jtwc-nio/jtwc-nio-intensity-bySSS_1979-2020_step2/';
path_drifter='/datas/drifterData/drifter_nio_sio_nwp_sp_nep_na-20220302/';
path_out='/datas/drifter_locations/';
folders_tc=dir(path_tc);

% drifter data
fileName_drifter='nio_drifter_interpolated_1979-2021.dat';
fid_drifter=fopen([path_drifter,fileName_drifter]);
data_drifter=textscan(fid_drifter,'%d%d%10.4f%10.4f%10.4f%10.4f%10.4f%10.4f','headerlines',1);
% data:id,datetime,lat,lon,T,Ve,Vn,speed
fclose(fid_drifter);
dateTime_drifter=data_drifter{2};
Lat_drifter=data_drifter{3};
Lon_drifter=data_drifter{4};
Temp_drifter=data_drifter{5};
U_drifter=data_drifter{6};
V_drifter=data_drifter{7};
Spd_drifter=data_drifter{8};
idx=find(Lat_drifter>999 | Lon_drifter>999 | Temp_drifter>999 | U_drifter>999 | V_drifter>999 | Spd_drifter>999);
dateTime_drifter(idx)=[];
Lat_drifter(idx)=[];
Lon_drifter(idx)=[];
Temp_drifter(idx)=[];
U_drifter(idx)=[];
V_drifter(idx)=[];
Spd_drifter(idx)=[];

fid_write = fopen([path_out,'nio_drifter within TC 7Rmax-TS1.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s','date_drifter','lat_drifter','lon_drifter', ...
    'Temp_drifter','u_drifter','v_drifter','spd_drifter','date_tc','lat_tc','lon_tc','r_along','r_cross');
fprintf(fid_write,'\n');

for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%s%s%s%s%s%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Rmax_tc=double(data_tc{10});
        pos=find(Lon_tc<30 | Lon_tc>100);
        dateTime_tc(pos)=[];
        Lat_tc(pos)=[];
        Lon_tc(pos)=[];
        Rmax_tc(pos)=[];
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==dateTime_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                
                for q=1:length(idx)
                    lat_drifter=Lat_drifter(idx(q));
                    lon_drifter=Lon_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',dateTime_drifter(idx(q)));  % datetime of drifter
                        fprintf(fid_write,'%15.4f',Lat_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Lon_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Temp_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',U_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',V_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Spd_drifter(idx(q)));
                        fprintf(fid_write,'%15d',dateTime_tc(p));  % datetime of tc
                        fprintf(fid_write,'%15.4f',lat_tc);
                        fprintf(fid_write,'%15.4f',lon_tc);
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'\n');
                    end
                end
            end
        end
    end
end
fclose(fid_write);



% NWP
clear;clc;
path_tc='/datas/JTWC/jtwc-intensity-bySSS_1979-2020_step2/';
path_drifter='/datas/drifterData/drifter_nio_sio_nwp_sp_nep_na-20220302/';
path_out='/datas/drifter_locations/';
folders_tc=dir(path_tc);

% drifter data
fileName_drifter='nwp_drifter_interpolated_1979-2021.dat';
fid_drifter=fopen([path_drifter,fileName_drifter]);
data_drifter=textscan(fid_drifter,'%d%d%10.4f%10.4f%10.4f%10.4f%10.4f%10.4f','headerlines',1);
% data:id,datetime,lat,lon,T,Ve,Vn,speed
fclose(fid_drifter);
dateTime_drifter=data_drifter{2};
Lat_drifter=data_drifter{3};
Lon_drifter=data_drifter{4};
Temp_drifter=data_drifter{5};
U_drifter=data_drifter{6};
V_drifter=data_drifter{7};
Spd_drifter=data_drifter{8};
idx=find(Lat_drifter>999 | Lon_drifter>999 | Temp_drifter>999 | U_drifter>999 | V_drifter>999 | Spd_drifter>999);
dateTime_drifter(idx)=[];
Lat_drifter(idx)=[];
Lon_drifter(idx)=[];
Temp_drifter(idx)=[];
U_drifter(idx)=[];
V_drifter(idx)=[];
Spd_drifter(idx)=[];

fid_write = fopen([path_out,'nwp_drifter within TC 7Rmax-TS1.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s','date_drifter','lat_drifter','lon_drifter', ...
    'Temp_drifter','u_drifter','v_drifter','spd_drifter','date_tc','lat_tc','lon_tc','r_along','r_cross');
fprintf(fid_write,'\n');

for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%s%s%s%s%s%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Rmax_tc=double(data_tc{10});
        pos=find(Lon_tc<100 | Lon_tc>180);
        dateTime_tc(pos)=[];
        Lat_tc(pos)=[];
        Lon_tc(pos)=[];
        Rmax_tc(pos)=[];
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==dateTime_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                
                for q=1:length(idx)
                    lat_drifter=Lat_drifter(idx(q));
                    lon_drifter=Lon_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',dateTime_drifter(idx(q)));  % datetime of drifter
                        fprintf(fid_write,'%15.4f',Lat_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Lon_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Temp_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',U_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',V_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Spd_drifter(idx(q)));
                        fprintf(fid_write,'%15d',dateTime_tc(p));  % datetime of tc
                        fprintf(fid_write,'%15.4f',lat_tc);
                        fprintf(fid_write,'%15.4f',lon_tc);
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'\n');
                    end
                end
            end
        end
    end
end
fclose(fid_write);



% SI
clear;clc;
path_tc='/datas/JTWC/jtwc-sh/jtwc-sh-intensity-bySSS_1979-2020_step2/';
path_drifter='/datas/drifterData/drifter_nio_sio_nwp_sp_nep_na-20220302/';
path_out='/datas/drifter_locations/';
folders_tc=dir(path_tc);

% drifter data
fileName_drifter='sio_drifter_interpolated_1979-2021.dat';
fid_drifter=fopen([path_drifter,fileName_drifter]);
data_drifter=textscan(fid_drifter,'%d%d%10.4f%10.4f%10.4f%10.4f%10.4f%10.4f','headerlines',1);
% data:id,datetime,lat,lon,T,Ve,Vn,speed
fclose(fid_drifter);
dateTime_drifter=data_drifter{2};
Lat_drifter=data_drifter{3};
Lon_drifter=data_drifter{4};
Temp_drifter=data_drifter{5};
U_drifter=data_drifter{6};
V_drifter=data_drifter{7};
Spd_drifter=data_drifter{8};
idx=find(Lat_drifter>999 | Lon_drifter>999 | Temp_drifter>999 | U_drifter>999 | V_drifter>999 | Spd_drifter>999);
dateTime_drifter(idx)=[];
Lat_drifter(idx)=[];
Lon_drifter(idx)=[];
Temp_drifter(idx)=[];
U_drifter(idx)=[];
V_drifter(idx)=[];
Spd_drifter(idx)=[];

fid_write = fopen([path_out,'sio_drifter within TC 7Rmax-TS1.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s','date_drifter','lat_drifter','lon_drifter', ...
    'Temp_drifter','u_drifter','v_drifter','spd_drifter','date_tc','lat_tc','lon_tc','r_along','r_cross');
fprintf(fid_write,'\n');

for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc) %
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%s%s%s%s%s%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Rmax_tc=double(data_tc{10});
        pos=find(Lon_tc<20 | Lon_tc>135);
        dateTime_tc(pos)=[];
        Lat_tc(pos)=[];
        Lon_tc(pos)=[];
        Rmax_tc(pos)=[];
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==dateTime_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                
                for q=1:length(idx)
                    lat_drifter=Lat_drifter(idx(q));
                    lon_drifter=Lon_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',dateTime_drifter(idx(q)));  % datetime of drifter
                        fprintf(fid_write,'%15.4f',Lat_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Lon_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Temp_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',U_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',V_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Spd_drifter(idx(q)));
                        fprintf(fid_write,'%15d',dateTime_tc(p));  % datetime of tc
                        fprintf(fid_write,'%15.4f',lat_tc);
                        fprintf(fid_write,'%15.4f',lon_tc);
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'\n');
                    end
                end
            end
        end
    end
end
fclose(fid_write);



% SP
clear;clc;
path_tc='/datas/JTWC/jtwc-sh/jtwc-sh-intensity-bySSS_1979-2020_step2/';
path_drifter='/datas/drifterData/drifter_nio_sio_nwp_sp_nep_na-20220302/';
path_out='/datas/drifter_locations/';
folders_tc=dir(path_tc);

% drifter data
fileName_drifter='sp_drifter_interpolated_1979-2021.dat';
fid_drifter=fopen([path_drifter,fileName_drifter]);
data_drifter=textscan(fid_drifter,'%d%d%10.4f%10.4f%10.4f%10.4f%10.4f%10.4f','headerlines',1);
% data:id,datetime,lat,lon,T,Ve,Vn,speed
fclose(fid_drifter);
dateTime_drifter=data_drifter{2};
Lat_drifter=data_drifter{3};
Lon_drifter=data_drifter{4};
Temp_drifter=data_drifter{5};
U_drifter=data_drifter{6};
V_drifter=data_drifter{7};
Spd_drifter=data_drifter{8};
idx=find(Lat_drifter>999 | Lon_drifter>999 | Temp_drifter>999 | U_drifter>999 | V_drifter>999 | Spd_drifter>999);
dateTime_drifter(idx)=[];
Lat_drifter(idx)=[];
Lon_drifter(idx)=[];
Temp_drifter(idx)=[];
U_drifter(idx)=[];
V_drifter(idx)=[];
Spd_drifter(idx)=[];

fid_write = fopen([path_out,'sp_drifter within TC 7Rmax-TS1.dat'],'w');
fprintf(fid_write,'%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s%15s','date_drifter','lat_drifter','lon_drifter', ...
    'Temp_drifter','u_drifter','v_drifter','spd_drifter','date_tc','lat_tc','lon_tc','r_along','r_cross');
fprintf(fid_write,'\n');

for i=3:4  % cat-1 & TS
    folder_tc=folders_tc(i).name;
    files_tc=dir([path_tc,folder_tc]);
    
    for j=3:length(files_tc)
        file_tc=files_tc(j).name;
        fid_tc=fopen([path_tc,folder_tc,'/',file_tc]);
        data_tc=textscan(fid_tc,'%d%f%f%d%s%s%s%s%s%d');
        fclose(fid_tc);
        dateTime_tc=data_tc{1};
        Lat_tc=data_tc{2};
        Lon_tc=data_tc{3};
        Lon_tc(Lon_tc<0)=Lon_tc(Lon_tc<0)+360;
        Rmax_tc=double(data_tc{10});
        pos=find(Lon_tc<135 | Lon_tc>290);
        dateTime_tc(pos)=[];
        Lat_tc(pos)=[];
        Lon_tc(pos)=[];
        Rmax_tc(pos)=[];
        
        for p=1:length(dateTime_tc)-1
            idx=find(dateTime_tc(p)==dateTime_drifter);
            
            if (~isempty(idx))
                lon_tc=Lon_tc(p);
                lon_tc(lon_tc>180)=lon_tc(lon_tc>180)-360;
                lat_tc=Lat_tc(p);
                
                lon_tc_next=Lon_tc(p+1);
                lon_tc_next(lon_tc_next>180)=lon_tc_next(lon_tc_next>180)-360;
                lat_tc_next=Lat_tc(p+1);
                
                [~,beta] = sw_dist([lat_tc,lat_tc_next],[lon_tc,lon_tc_next],'nm');
                
                Rmax=Rmax_tc(p);
                
                for q=1:length(idx)
                    lat_drifter=Lat_drifter(idx(q));
                    lon_drifter=Lon_drifter(idx(q));
                    lon_drifter(lon_drifter>180)=lon_drifter(lon_drifter>180)-360;
                    
                    [dist,phaseangle]=sw_dist([lat_tc,lat_drifter],[lon_tc,lon_drifter],'nm');
                    r = dist/Rmax;
                    r_along = r*cosd(phaseangle-beta);
                    r_cross = -r*sind(phaseangle-beta);
                    
                    if (abs(r_along)<=7 && abs(r_cross)<=7)
                        fprintf(fid_write,'%15d',dateTime_drifter(idx(q)));  % datetime of drifter
                        fprintf(fid_write,'%15.4f',Lat_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Lon_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Temp_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',U_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',V_drifter(idx(q)));
                        fprintf(fid_write,'%15.4f',Spd_drifter(idx(q)));
                        fprintf(fid_write,'%15d',dateTime_tc(p));  % datetime of tc
                        fprintf(fid_write,'%15.4f',lat_tc);
                        fprintf(fid_write,'%15.4f',lon_tc);
                        fprintf(fid_write,'%15.4f',r_along);
                        fprintf(fid_write,'%15.4f',r_cross);
                        fprintf(fid_write,'\n');
                    end
                end
            end
        end
    end
end
fclose(fid_write);




