% figure 3 code 5


clear;clc;
path_drifter='/datas/current in storm-coordinate system/';
path_out='/datas/mean_current_within7Rmax/';

files = dir([path_drifter,'*ageostrophicFlowInStormCoordinateSystem_withinTC7Rmax_TS1_19792020.dat']);

year_drifter_all=[];
r_along_all=[];
r_cross_all=[];
U_drifter_all=[];
V_drifter_all=[];
for i=1:4  % 5:length(files) % na,nep,nio,nwp,sio,sp
    file=files(i).name;
    fid=fopen([path_drifter,file],'r');
    data=textscan(fid,'%15d%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15d%15.4f%15.4f%15d%15d','headerlines',1);
    fclose(fid);
    datetime_drifter=data{1};
    datetimestr_drifter=num2str(datetime_drifter);
    year_drifter=str2num(datetimestr_drifter(:,1:4));
    clear datetime_drifter datetimestr_drifter;
    r_along=data{4};
    r_cross=data{5};
    V_drifter=data{6}.*100; % cm/s
    U_drifter=data{7}.*100; % cm/s
    
    idx=sqrt(U_drifter.^2+V_drifter.^2)<500;
    year_drifter=year_drifter(idx);
    r_along=r_along(idx);
    r_cross=r_cross(idx);
    V_drifter=V_drifter(idx);
    U_drifter=U_drifter(idx);
    
    year_drifter_all=[year_drifter_all;year_drifter];
    r_along_all=[r_along_all;r_along];
    r_cross_all=[r_cross_all;r_cross];
    U_drifter_all=[U_drifter_all;U_drifter];
    V_drifter_all=[V_drifter_all;V_drifter];
    clear file fid data year_drifter r_along r_cross V_drifter U_drifter idx
end

years=[1991 2006 2021];
[x,y]=meshgrid(-7:1:7,-7:1:7);
mean_U_drifter=NaN(15,15,2);
mean_V_drifter=NaN(15,15,2);
for j = 1:2  % 1991-2005,2006-2020
    pos = find(year_drifter_all>=years(j) & year_drifter_all<years(j+1));
    r_along1 = r_along_all(pos);
    r_cross1 = r_cross_all(pos);
    U_drifter1 = U_drifter_all(pos);
    V_drifter1 = V_drifter_all(pos);
    
    tf=find(isnan(U_drifter1) | isnan(V_drifter1) | abs(r_along1)>7 | abs(r_cross1)>7);
    r_cross1(tf)=[];
    r_along1(tf)=[];
    U_drifter1(tf)=[];
    V_drifter1(tf)=[];
    
    r=2;
    mean_U_drifter(:,:,j)=barnes(r_cross1,r_along1,U_drifter1,x,y,r,r);
    mean_V_drifter(:,:,j)=barnes(r_cross1,r_along1,V_drifter1,x,y,r,r);
end
mean_speed=sqrt(mean_U_drifter.^2+mean_V_drifter.^2);
save([path_out,'nh_mean_current_vectors_TS1_1991_2020.mat'],'mean_U_drifter','mean_V_drifter','mean_speed');
% save([path_out,'sh_mean_current_vectors_TS1_1991_2020.mat'],'mean_U_drifter','mean_V_drifter','mean_speed');




