% figure 3 plot


%%% fig.3a
clear;clc;
path_in='/datas/fig3/';
path_figure='/figures/fig3/';

[x,y]=meshgrid(-7:1:7,-7:1:7);

files = dir([path_in,'*ageostrophicFlowInStormCoordinateSystem_withinTC7Rmax_TS1_19792020.dat']);

year_drifter_nh_all=[];
U_drifter_nh_all=[];
V_drifter_nh_all=[];
r_along_nh_all=[];
r_cross_nh_all=[];
for i=1:4
    file=files(i).name;
    fid=fopen([path_in,file],'r');
    data=textscan(fid,'%15d%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15d%15.4f%15.4f%15d%15d','headerlines',1);
    fclose(fid);
    datetime_drifter=data{1};
    datetimestr_drifter=num2str(datetime_drifter);
    year_drifter=str2num(datetimestr_drifter(:,1:4));
    clear datetime_drifter datetimestr_drifter;
    r_along=data{4};
    r_cross=data{5};
    V_drifter=data{6}.*100;
    U_drifter=data{7}.*100;
    
    idx=sqrt(U_drifter.^2+V_drifter.^2)>500 | isnan(U_drifter) | isnan(V_drifter);
    year_drifter(idx)=[];
    U_drifter(idx)=[];
    V_drifter(idx)=[];
    r_along(idx)=[];
    r_cross(idx)=[];
    
    year_drifter_nh_all=[year_drifter_nh_all;year_drifter];
    U_drifter_nh_all=[U_drifter_nh_all;U_drifter];
    V_drifter_nh_all=[V_drifter_nh_all;V_drifter];
    r_along_nh_all=[r_along_nh_all;r_along];
    r_cross_nh_all=[r_cross_nh_all;r_cross];
    clear file fid datetime_drifter datetimestr_drifter data U_drifter V_drifter r_along r_cross year_drifter idx
end

year_drifter_sh_all=[];
U_drifter_sh_all=[];
V_drifter_sh_all=[];
r_along_sh_all=[];
r_cross_sh_all=[];
for i=5:6
    file=files(i).name;
    fid=fopen([path_in,file],'r');
    data=textscan(fid,'%15d%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f%15d%15.4f%15.4f%15d%15d','headerlines',1);
    fclose(fid);
    datetime_drifter=data{1};
    datetimestr_drifter=num2str(datetime_drifter);
    year_drifter=str2num(datetimestr_drifter(:,1:4));
    clear datetime_drifter datetimestr_drifter;
    r_along=data{4};
    r_cross=data{5};
    V_drifter=data{6}.*100;
    U_drifter=data{7}.*100;
    
    idx=sqrt(U_drifter.^2+V_drifter.^2)>500 | isnan(U_drifter) | isnan(V_drifter);
    year_drifter(idx)=[];
    U_drifter(idx)=[];
    V_drifter(idx)=[];
    r_along(idx)=[];
    r_cross(idx)=[];
    
    year_drifter_sh_all=[year_drifter_sh_all;year_drifter];
    U_drifter_sh_all=[U_drifter_sh_all;U_drifter];
    V_drifter_sh_all=[V_drifter_sh_all;V_drifter];
    r_along_sh_all=[r_along_sh_all;r_along];
    r_cross_sh_all=[r_cross_sh_all;r_cross];
    clear file fid datetime_drifter datetimestr_drifter data U_drifter V_drifter r_along r_cross year_drifter idx
end

year_drifter_all=[year_drifter_nh_all;year_drifter_sh_all];
U_drifter_all=[U_drifter_nh_all;U_drifter_sh_all];
V_drifter_all=[V_drifter_nh_all;V_drifter_sh_all];
r_cross_sh_all=-r_cross_sh_all;
r_along_all=[r_along_nh_all;r_along_sh_all];
r_cross_all=[r_cross_nh_all;r_cross_sh_all];
clear i path_drifter files r_along_nh_all r_along_sh_all r_cross_nh_all r_cross_sh_all U_drifter_nh_all ...
    U_drifter_sh_all V_drifter_nh_all V_drifter_sh_all year_drifter_nh_all year_drifter_sh_all

pos = find(year_drifter_all>=1991 & year_drifter_all<2006);
r_along1 = r_along_all(pos);
r_cross1 = r_cross_all(pos);
U_drifter1 = U_drifter_all(pos);
V_drifter1 = V_drifter_all(pos);
pos = find(year_drifter_all>=2006 & year_drifter_all<2021);
r_along2 = r_along_all(pos);
r_cross2 = r_cross_all(pos);
U_drifter2 = U_drifter_all(pos);
V_drifter2 = V_drifter_all(pos);
clear pos


% sh
load([path_in,'sh_mean_current_vectors_TS1_1991_2020.mat']);
mean_U_drifter_sh=mean_U_drifter;
mean_V_drifter_sh=mean_V_drifter;
mean_speed_sh=mean_speed;
clear mean_U_drifter mean_V_drifter mean_speed
for m=1:2
    mean_U_drifter_sh(:,:,m)=-fliplr(mean_U_drifter_sh(:,:,m));
    mean_V_drifter_sh(:,:,m)=fliplr(mean_V_drifter_sh(:,:,m));
    mean_speed_sh(:,:,m)=fliplr(mean_speed_sh(:,:,m));
end
% nh
load([path_in,'nh_mean_current_vectors_TS1_1991_2020.mat']);
mean_U_drifter_nh=mean_U_drifter;
mean_V_drifter_nh=mean_V_drifter;
mean_speed_nh=mean_speed;
clear mean_U_drifter mean_V_drifter mean_speed
for m=1:2
    mean_U_drifter(:,:,m)=(mean_U_drifter_sh(:,:,m)+mean_U_drifter_nh(:,:,m))./2;
    mean_V_drifter(:,:,m)=(mean_V_drifter_sh(:,:,m)+mean_V_drifter_nh(:,:,m))./2;
    mean_speed(:,:,m)=(mean_speed_sh(:,:,m)+mean_speed_nh(:,:,m))./2;
end
clear m


% plot
f=figure;
set(f,'unit','centimeters','position',[2,5,25,25]);

% 1991-2005
subplot('position',[0.23 0.72 0.17 0.17]);
% standard error ellipse in each grid
c1=-8.5;
c2=-7.5;
lon0=-8;
for cc=1:1:15
    lon0=lon0+1;
    c1=c1+1;
    c2=c2+1;
    tf1=find(r_cross1>=c1 & r_cross1<=c2);
    
    r1=-8.5;
    r2=-7.5;
    lat0=-8;
    for rr=1:1:15
        lat0=lat0+1;
        r1=r1+1;
        r2=r2+1;
        tf2=find(r_along1>=r1 & r_along1<=r2);
        
        tf=intersect(tf1,tf2);
        
        if length(tf)>1
            % construct a new data array
            data = [U_drifter1(tf) V_drifter1(tf)]./100;  % m/s
            % Calculate the covariance
            covariance = cov(data);
            
            H=error_ellipse(covariance,[lon0,lat0]);
            hold on
        end
    end
end
contourf(x,y,mean_speed(:,:,1),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,1),mean_V_drifter(:,:,1),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',-6:2:6);
set(gca,'ytick',-6:2:6,'yticklabel',-6:2:6);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
xlabel('Cross-track distance,Rmax','fontname','Arial','fontunits','point','fontsize',7);
ylabel('Along-track distance,Rmax','fontname','Arial','fontunits','point','fontsize',7);
title('1991-2005','fontname','Arial','fontunits','point','fontsize',7);
text(-7,7.75,'a','fontname','Arial','fontunits','point','fontsize',8,'fontweight','bold');

% 2006-2020
subplot('position',[0.42 0.72 0.17 0.17]);
% compute standard error ellipse in each grid
c1=-8.5;
c2=-7.5;
lon0=-8;
for cc=1:1:15
    lon0=lon0+1;
    c1=c1+1;
    c2=c2+1;
    tf1=find(r_cross2>=c1 & r_cross2<=c2);
    
    r1=-8.5;
    r2=-7.5;
    lat0=-8;
    for rr=1:1:15
        lat0=lat0+1;
        r1=r1+1;
        r2=r2+1;
        tf2=find(r_along2>=r1 & r_along2<=r2);
        
        tf=intersect(tf1,tf2);
        
        if length(tf)>1
            % construct a new data array
            data = [U_drifter2(tf) V_drifter2(tf)]./100;  % m/s
            % Calculate the covariance
            covariance = cov(data);
            
            H=error_ellipse(covariance,[lon0,lat0]);
            hold on
        end
    end
end
contourf(x,y,mean_speed(:,:,2),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,2),mean_V_drifter(:,:,2),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',-6:2:6);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
title('2006-2020','fontname','Arial','fontunits','point','fontsize',7);
% colorbar
h1=colorbar('horiz');
set(h1,'position',[0.23,0.94 0.36 0.015]);
set(h1,'xtick',0:5:40,'xticklabel',0:5:40,'ticklength',0.015,'fontname','Arial','fontsize',7);
text(-9,10.5,'cm/s','fontname','Arial','fontunits','point','fontsize',7);

% 2006-2020 - 1991-2005
anom_mean_speed=mean_speed(:,:,2)-mean_speed(:,:,1);
anom_U_drifter=mean_U_drifter(:,:,2)-mean_U_drifter(:,:,1);
anom_V_drifter=mean_V_drifter(:,:,2)-mean_V_drifter(:,:,1);
subplot('position',[0.61 0.72 0.17 0.17]);
contourf(x,y,anom_mean_speed,10,'linecolor','none');
caxis([-25 25]);
mycolor=m_colmap('diverging','step',10);
colormap(gca,mycolor(1:26:end,:));
axis square
box on
hold on
quiver(x,y,anom_U_drifter,anom_V_drifter,1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',-6:2:6);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
title('change','fontname','Arial','fontunits','point','fontsize',7);
text(3.5,6,'Global','fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');
% colorbar
h2=colorbar('horiz');
set(h2,'position',[0.61,0.94 0.17 0.015]);
set(h2,'xtick',-20:10:20,'xticklabel',-20:10:20,'ticklength',0.03,'fontname','Arial','fontsize',7);
text(-1,10.5,'cm/s','fontname','Arial','fontunits','point','fontsize',7);

set(f,'RendererMode','manual','Renderer','painters');
print('-r600',[path_figure,'global mean current vectors within TC 7Rmax_TS1_1991-2020'],'-depsc');
close(f);





%%% fig.3b
clear;clc;
path_in='/datas/fig3/';
path_figure='/figures/fig3/';

[x,y]=meshgrid(-7:1:7,-7:1:7);

% plot

f=figure;
set(f,'unit','centimeters','position',[2,5,25,25]);

%%% na %%%
load([path_in,'na_1991_2020.mat'])
% 1991-2005
subplot('position',[0.23 0.8 0.17 0.17]);
contourf(x,y,mean_speed(:,:,1),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,1),mean_V_drifter(:,:,1),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',-6:2:6);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
title('1991-2005','fontname','Arial','fontunits','point','fontsize',7);
text(-7,7.75,'b','fontname','Arial','fontunits','point','fontsize',8,'fontweight','bold');
% 2006-2020
subplot('position',[0.42 0.8 0.17 0.17]);
contourf(x,y,mean_speed(:,:,2),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,2),mean_V_drifter(:,:,2),1,'r','MaxHeadSize',0.5,'LineWidth',.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
title('2006-2020','fontname','Arial','fontunits','point','fontsize',7);
% 2006-2020 - 1991-2005
anom_mean_speed=mean_speed(:,:,2)-mean_speed(:,:,1);
anom_U_drifter=mean_U_drifter(:,:,2)-mean_U_drifter(:,:,1);
anom_V_drifter=mean_V_drifter(:,:,2)-mean_V_drifter(:,:,1);
subplot('position',[0.61 0.8 0.17 0.17]);
contourf(x,y,anom_mean_speed,10,'linecolor','none');
caxis([-25 25]);
mycolor=m_colmap('diverging','step',10);
colormap(gca,mycolor(1:26:end,:));
axis square
box on
hold on
quiver(x,y,anom_U_drifter,anom_V_drifter,1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
title('change','fontname','Arial','fontunits','point','fontsize',7);
text(4.5,6,'NA','fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');

%%% nep %%%
load([path_in,'nep_1991_2020.mat'])
% 1991-2005
subplot('position',[0.23 0.625 0.17 0.17]);
contourf(x,y,mean_speed(:,:,1),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,1),mean_V_drifter(:,:,1),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',-6:2:6);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
% 2006-2020
subplot('position',[0.42 0.625 0.17 0.17]);
contourf(x,y,mean_speed(:,:,2),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,2),mean_V_drifter(:,:,2),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
% 2006-2020 - 1991-2005
anom_mean_speed=mean_speed(:,:,2)-mean_speed(:,:,1);
anom_U_drifter=mean_U_drifter(:,:,2)-mean_U_drifter(:,:,1);
anom_V_drifter=mean_V_drifter(:,:,2)-mean_V_drifter(:,:,1);
subplot('position',[0.61 0.625 0.17 0.17]);
contourf(x,y,anom_mean_speed,10,'linecolor','none');
caxis([-25 25]);
mycolor=m_colmap('diverging','step',10);
colormap(gca,mycolor(1:26:end,:));
axis square
box on
hold on
quiver(x,y,anom_U_drifter,anom_V_drifter,1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
text(4.5,6,'NEP','fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');

%%% nwp %%%
load([path_in,'nwp_1991_2020.mat'])
% 1991-2005
subplot('position',[0.23 0.45 0.17 0.17]);
contourf(x,y,mean_speed(:,:,1),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,1),mean_V_drifter(:,:,1),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',-6:2:6);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
% 2006-2020
subplot('position',[0.42 0.45 0.17 0.17]);
contourf(x,y,mean_speed(:,:,2),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,2),mean_V_drifter(:,:,2),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
% 2006-2020 - 1991-2005
anom_mean_speed=mean_speed(:,:,2)-mean_speed(:,:,1);
anom_U_drifter=mean_U_drifter(:,:,2)-mean_U_drifter(:,:,1);
anom_V_drifter=mean_V_drifter(:,:,2)-mean_V_drifter(:,:,1);
subplot('position',[0.61 0.45 0.17 0.17]);
contourf(x,y,anom_mean_speed,10,'linecolor','none');
caxis([-25 25]);
mycolor=m_colmap('diverging','step',10);
colormap(gca,mycolor(1:26:end,:));
axis square
box on
hold on
quiver(x,y,anom_U_drifter,anom_V_drifter,1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
text(4.5,6,'NWP','fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');

%%% si %%%
load([path_in,'sio_1991_2020.mat'])
% 1991-2005
subplot('position',[0.23 0.275 0.17 0.17]);
contourf(x,y,mean_speed(:,:,1),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,1),mean_V_drifter(:,:,1),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',-6:2:6);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
% 2006-2020
subplot('position',[0.42 0.275 0.17 0.17]);
contourf(x,y,mean_speed(:,:,2),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,2),mean_V_drifter(:,:,2),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
% 2006-2020 - 1991-2005
anom_mean_speed=mean_speed(:,:,2)-mean_speed(:,:,1);
anom_U_drifter=mean_U_drifter(:,:,2)-mean_U_drifter(:,:,1);
anom_V_drifter=mean_V_drifter(:,:,2)-mean_V_drifter(:,:,1);
subplot('position',[0.61 0.275 0.17 0.17]);
contourf(x,y,anom_mean_speed,10,'linecolor','none');
caxis([-25 25]);
mycolor=m_colmap('diverging','step',10);
colormap(gca,mycolor(1:26:end,:));
axis square
box on
hold on
quiver(x,y,anom_U_drifter,anom_V_drifter,1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',[]);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
text(4.5,6,'SI','fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');

%%% sp %%%
load([path_in,'sp_1991_2020.mat'])
% 1991-2005
subplot('position',[0.23 0.1 0.17 0.17]);
contourf(x,y,mean_speed(:,:,1),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,1),mean_V_drifter(:,:,1),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',-6:2:6);
set(gca,'ytick',-6:2:6,'yticklabel',-6:2:6);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
xlabel('Cross-track distance,Rmax','fontname','Arial','fontunits','point','fontsize',7);
ylabel('Along-track distance,Rmax','fontname','Arial','fontunits','point','fontsize',7);
% 2006-2020
subplot('position',[0.42 0.1 0.17 0.17]);
contourf(x,y,mean_speed(:,:,2),10,'linecolor','none');
caxis([0 40]);
colormap(viridis(8));
axis square
box on
hold on
quiver(x,y,mean_U_drifter(:,:,2),mean_V_drifter(:,:,2),1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',-6:2:6);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
% 2006-2020 - 1991-2005
anom_mean_speed=mean_speed(:,:,2)-mean_speed(:,:,1);
anom_U_drifter=mean_U_drifter(:,:,2)-mean_U_drifter(:,:,1);
anom_V_drifter=mean_V_drifter(:,:,2)-mean_V_drifter(:,:,1);
subplot('position',[0.61 0.1 0.17 0.17]);
contourf(x,y,anom_mean_speed,10,'linecolor','none');
caxis([-25 25]);
mycolor=m_colmap('diverging','step',10);
colormap(gca,mycolor(1:26:end,:));
axis square
box on
hold on
quiver(x,y,anom_U_drifter,anom_V_drifter,1,'r','MaxHeadSize',0.5,'LineWidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',-6:2:6);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.02,0.02],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
axis square
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
text(4.5,6,'SP','fontname','Arial','fontunits','point','fontsize',7,'fontweight','bold');

set(f,'RendererMode','manual','Renderer','painters');
print('-r600',[path_figure,'each basins mean current vectors within TC 7Rmax_TS1_1991-2020'],'-depsc');
close(f);




