% figure 4 code 2


clear;clc;
path_sst='/Elements/NOAA-daily-OISST/';
path_out='/datas/sst_clim/';

files=dir([path_sst,'*.nc']);

year_all=NaN(length(files),1);
for i=1:length(files)
    file=[path_sst,files(i).name];
    year=file(62:65);
    year_all(i)=str2double(year);
end
year_unique=unique(year_all);
clear year i file

lat_sst=(-89.875:0.25:89.875)';
lon_sst=(0.125:0.25:359.875)';
sst_daily_all=zeros(length(lat_sst),length(lon_sst),366);
mask_daily_all=zeros(length(lat_sst),length(lon_sst),366);

N=3409;
for i=11:25  % 11:25,1991-2005  26:40,2006-2020
    disp(i);
    num_sameyear=length(find(year_unique(i)==year_all));
    
    for j=N+1:N+num_sameyear
        file=[path_sst,files(j).name];
        datestr_sst=file(62:69);
        
        day0=datenum(str2double(datestr_sst(1:4)),str2double(datestr_sst(5:6)),str2double(datestr_sst(7:8)));
        v = datevec(day0);
        day1 = datenum(v(1),01,01);
        dd = day0-day1;
        year_day=dd+1;
        clear day0 v day1 dd
        
        if(~((rem(str2double(datestr_sst(1:4)),100)~= 0 && rem(str2double(datestr_sst(1:4)),4) == 0) ||...
                (rem(str2double(datestr_sst(1:4)),100) == 0 && rem(str2double(datestr_sst(1:4)),400) == 0)))
            if (year_day>59)
                year_day=year_day+1;
            end
        end
        
        % ncdisp(file);
        sst=ncread(file,'sst');
        sst=sst';
        
        mask=~isnan(sst);
        mask_daily_all(:,:,year_day)=mask_daily_all(:,:,year_day)+mask;
        sst(isnan(sst))=0;
        sst_daily_all(:,:,year_day)=sst_daily_all(:,:,year_day)+sst;
        clear sst mask
    end
    N=N+num_sameyear;
end

for i=1:366
    sst_clim=sst_daily_all(:,:,i)./mask_daily_all(:,:,i);
    
    save([path_out,'global-sst_clim1991_',num2str(i),'.mat'],'sst_clim');
    clear sst
end



clear;clc;
path_out='/datas/sst_clim/';

lat_sst=(-89.875:0.25:89.875)';
lon_sst=(0.125:0.25:359.875)';
sst_clim_1991_2005=nan(length(lat_sst),length(lon_sst),366);
for i=1:366
    load([path_out,'global-sst_clim1991_',num2str(i),'.mat']);
    
    sst_clim_1991_2005(:,:,i)=sst_clim;
    clear sst_clim
end
save([path_out,'global-sst_clim1991.mat'],'sst_clim_1991_2005','lon_sst','lat_sst','-v7.3');





% 2006-2020
clear;clc;
path_sst='/Elements/NOAA-daily-OISST/';
path_out='/datas/sst_clim/';

files=dir([path_sst,'*.nc']);

year_all=NaN(length(files),1);
for i=1:length(files)
    file=[path_sst,files(i).name];
    year=file(62:65);
    year_all(i)=str2double(year);
end
year_unique=unique(year_all);
clear year i file

lat_sst=(-89.875:0.25:89.875)';
lon_sst=(0.125:0.25:359.875)';
sst_daily_all=zeros(length(lat_sst),length(lon_sst),366);
mask_daily_all=zeros(length(lat_sst),length(lon_sst),366);

N=8888;
for i=26:40   % 11:25,1991-2005   26:40,2006-2020
    disp(i);
    num_sameyear=length(find(year_unique(i)==year_all));
    
    for j=N+1:N+num_sameyear
        file=[path_sst,files(j).name];
        datestr_sst=file(62:69);
        
        day0=datenum(str2double(datestr_sst(1:4)),str2double(datestr_sst(5:6)),str2double(datestr_sst(7:8)));
        v = datevec(day0);
        day1 = datenum(v(1),01,01);
        dd = day0-day1;
        year_day=dd+1;
        clear day0 v day1 dd
        
        if(~((rem(str2double(datestr_sst(1:4)),100)~= 0 && rem(str2double(datestr_sst(1:4)),4) == 0) ||...
                (rem(str2double(datestr_sst(1:4)),100) == 0 && rem(str2double(datestr_sst(1:4)),400) == 0)))
            if (year_day>59)
                year_day=year_day+1;
            end
        end
        
        % ncdisp(file);
        sst=ncread(file,'sst');
        sst=sst';
        
        mask=~isnan(sst);
        mask_daily_all(:,:,year_day)=mask_daily_all(:,:,year_day)+mask;
        sst(isnan(sst))=0;
        sst_daily_all(:,:,year_day)=sst_daily_all(:,:,year_day)+sst;
        clear sst mask
    end
    N=N+num_sameyear;
end

for i=1:366
    sst_clim=sst_daily_all(:,:,i)./mask_daily_all(:,:,i);
    
    save([path_out,'global-sst_clim2006_',num2str(i),'.mat'],'sst_clim');
    clear sst
end



clear;clc;
path_out='/datas/sst_clim/';

lat_sst=(-89.875:0.25:89.875)';
lon_sst=(0.125:0.25:359.875)';
sst_clim_2006_2020=nan(length(lat_sst),length(lon_sst),366);
for i=1:366
    load([path_out,'global-sst_clim2006_',num2str(i),'.mat']);
    
    sst_clim_2006_2020(:,:,i)=sst_clim;
    clear sst_clim
end
save([path_out,'global-sst_clim2006.mat'],'sst_clim_2006_2020','lon_sst','lat_sst','-v7.3');




