% figure 4 code 3


clear;clc;
path_sst ='/Elements/NOAA-daily-OISST/';
path_drifter='/datas/drifter_Temp/';
path_out='/datas/ssta_relative2climsst/';

files_drifter=dir([path_drifter,'*drifterT within TC 7Rmax-TS1.dat']);

load('/datas/sst_clim/global-sst_clim1991.mat');
load('/datas/sst_clim/global-sst_clim2006.mat');

date_drifter_all=[];
lat_drifter_all=[];
lon_drifter_all=[];
T_drifter_all=[];
date_tc_all=[];
lat_tc_all=[];
lon_tc_all=[];
lat_tc_next_all=[];
lon_tc_next_all=[];
Rmax_all=[];
for i=1:4  % 1:length(files)  % na,nep,nio,nwp,sio,sp
    file=files_drifter(i).name;
    fid=fopen([path_drifter,file]);
    data=textscan(fid,'%d%f%f%f%d%f%f%f%f%d','headerlines',1);
    fclose(fid);
    date_drifter_all=[date_drifter_all;data{1}];
    lat_drifter_all=[lat_drifter_all;data{2}];
    lon_drifter_all=[lon_drifter_all;data{3}];
    T_drifter_all=[T_drifter_all;data{4}];
    date_tc_all=[date_tc_all;data{5}];
    lat_tc_all=[lat_tc_all;data{6}];
    lon_tc_all=[lon_tc_all;data{7}];
    lat_tc_next_all=[lat_tc_next_all;data{8}];
    lon_tc_next_all=[lon_tc_next_all;data{9}];
    Rmax_all=[Rmax_all;data{10}];
end

mask_all_1=zeros(15,15);   % 1991-2005
anom_sst_all_1=zeros(15,15);
mask_all_2=zeros(15,15);   % 2006-2020
anom_sst_all_2=zeros(15,15);

lon_region=-7:1:7;
lat_region=-7:1:7;
[LON,LAT]=meshgrid(lon_region,lat_region);

for j=1:length(date_drifter_all)
    date_sst=num2str(date_drifter_all(j));
    date_sst=date_sst(1:8);
    
    if (str2double(date_sst)>=19910101 && str2double(date_sst)<=20201231)
        file_sst = dir([path_sst,'*',date_sst,'.nc']);
        filename_sst = ([path_sst,file_sst(1).name]);
        
        % ncdisp(filename_sst);
        sst=ncread(filename_sst,'sst');
        sst=sst';
        
        day0=datenum(str2double(date_sst(1:4)),str2double(date_sst(5:6)),str2double(date_sst(7:8)));
        v = datevec(day0);
        day1 = datenum(v(1),01,01);
        dd = day0-day1;
        year_day=dd+1;
        clear day0 v day1 dd
        
        if(~((rem(str2double(date_sst(1:4)),100)~= 0 && rem(str2double(date_sst(1:4)),4) == 0) ||...
                (rem(str2double(date_sst(1:4)),100) == 0 && rem(str2double(date_sst(1:4)),400) == 0)))
            if (year_day>59)
                year_day=year_day+1;
            end
        end
        
        % anomaly sst
        if (str2double(date_sst)>=19910101 && str2double(date_sst)<=20051231)
            anom_sst=sst-sst_clim_1991_2005(:,:,year_day);
        elseif (str2double(date_sst)>=20060101 && str2double(date_sst)<=20201231)
            anom_sst=sst-sst_clim_2006_2020(:,:,year_day);
        end
        
        Rmax=double(Rmax_all(j));
        lon_origin=lon_tc_all(j);
        lon_origin(lon_origin>180)=lon_origin(lon_origin>180)-360;
        lat_origin=lat_tc_all(j);
        
        lon_origin_next=lon_tc_next_all(j);
        lon_origin_next(lon_origin_next>180)=lon_origin_next(lon_origin_next>180)-360;
        lat_origin_next=lat_tc_next_all(j);
        [~,beta]=sw_dist([lat_origin,lat_origin_next],[lon_origin,lon_origin_next],'nm');
        
        lon_origin(lon_origin<0)=lon_origin(lon_origin<0)+360;
        good_lon=lon_sst-lon_origin<=6  & lon_sst-lon_origin>=-6;
        good_lat=lat_sst-lat_origin<=5  & lat_sst-lat_origin>=-5;
        lon_sst_good=lon_sst(good_lon);
        lat_sst_good=lat_sst(good_lat);
        sub_anom_sst=anom_sst(good_lat,good_lon);
        
        lon_origin(lon_origin>180)=lon_origin(lon_origin>180)-360;
        [a,b]=size(sub_anom_sst);
        r_all=NaN(a,b);
        phaseangle_all=NaN(a,b);
        [LON_sst_good,LAT_sst_good]=meshgrid(lon_sst_good,lat_sst_good);
        for p=1:a
            for q=1:b
                lon_grid_sst=LON_sst_good(p,q);
                lon_grid_sst(lon_grid_sst>180)=lon_grid_sst(lon_grid_sst>180)-360;
                lat_grid_sst=LAT_sst_good(p,q);
                [dist,phaseangle] = sw_dist([lat_origin,lat_grid_sst],[lon_origin,lon_grid_sst],'nm');
                r=dist/Rmax;
                
                r_all(p,q)=r;
                phaseangle_all(p,q)=phaseangle;
            end
        end
        
        if (~isnan(beta))
            r_along_all=r_all.*cosd(phaseangle_all-beta);
            r_cross_all=-r_all.*sind(phaseangle_all-beta);
            
            anom_sst_10R=griddata(r_cross_all,r_along_all,sub_anom_sst,LON,LAT);
            
            if (str2double(date_sst)>=19910101 && str2double(date_sst)<=20051231)
                mask=~isnan(anom_sst_10R);
                mask_all_1=mask_all_1+mask;
                anom_sst_10R(isnan(anom_sst_10R))=0;
                anom_sst_all_1=anom_sst_all_1+anom_sst_10R;
            elseif (str2double(date_sst)>=20060101 && str2double(date_sst)<=20201231)
                mask=~isnan(anom_sst_10R);
                mask_all_2=mask_all_2+mask;
                anom_sst_10R(isnan(anom_sst_10R))=0;
                anom_sst_all_2=anom_sst_all_2+anom_sst_10R;
            end
        end
    end
end
mean_anom_sst_1=anom_sst_all_1./mask_all_1;
mean_anom_sst_2=anom_sst_all_2./mask_all_2;

save([path_out,'nh-mean_anomSST_clim_1991_2006.mat'],'mean_anom_sst_1','mean_anom_sst_2');
% save([path_out,'sh-mean_anomSST_clim_1991_2006.mat'],'mean_anom_sst_1','mean_anom_sst_2');




