% figure 4 plot


clear;clc;
path_in='/datas/fig4/';
path_figure='/figures/fig4/';

load([path_in,'nh-mean_anomSST_clim_1991_2006.mat']);
nh_ssta_1=mean_anom_sst_1;
nh_ssta_2=mean_anom_sst_2;
clear mean_anom_sst_1 mean_anom_sst_2

load([path_in,'sh-mean_anomSST_clim_1991_2006.mat']);
sh_ssta_1=fliplr(mean_anom_sst_1);
sh_ssta_2=fliplr(mean_anom_sst_2);
clear mean_anom_sst_1 mean_anom_sst_2

ssta_1=(nh_ssta_1+sh_ssta_1)./2;
ssta_2=(nh_ssta_2+sh_ssta_2)./2;


% plot
f=figure;
set(f,'unit','centimeters','position',[5,5,25,25]);

% 1991-2005
g1=subplot('position',[0.05 0.45 0.3 0.3]);
contourf(-7:7,-7:7,ssta_1,10,'linecolor','none');
caxis([-0.5 0]);
colormap(g1,viridis(10));
axis square
box  on
hold on
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',-6:2:6);
set(gca,'ytick',-6:2:6,'yticklabel',-6:2:6);
set(gca,'ticklength',[0.015,0.015],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
xlabel('Cross-track distance,Rmax','fontname','Arial','fontunits','point','fontsize',7);
ylabel('Along-track distance,Rmax','fontname','Arial','fontunits','point','fontsize',7);
title('1991-2005','fontname','Arial','fontunits','point','fontsize',7);
text(-6.8,6.5,'a','fontname','Arial','fontunits','point','fontsize',8,'fontweight','bold');

% 2006-2020
g2=subplot('position',[0.36 0.45 0.3 0.3]);
contourf(-7:7,-7:7,ssta_2,10,'linecolor','none');
caxis([-0.5 0]);
colormap(g2,viridis(10));
axis square
box on
hold on
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',-6:2:6);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.015,0.015],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
title('2006-2020','fontname','Arial','fontunits','point','fontsize',7);
text(-6.8,6.5,'b','fontname','Arial','fontunits','point','fontsize',8,'fontweight','bold');
% colorbar
h1=colorbar('horiz');
set(h1,'position',[0.06,0.37 0.59 0.02]);
set(h1,'ytick',-0.5:0.05:0,'yticklabel',{'-0.5','-0.45','-0.4','-0.35','-0.3','-0.25','-0.2','-0.15','-0.1','-0.05','0'},'fontname','Arial','fontsize',7,'ticklength',0.01);
text(-7.7,-9.3,'\circC','fontname','Arial','fontunits','point','fontsize',7);

% 2006-2020 - 1991-2005
g3=subplot('position',[0.67 0.45 0.3 0.3]);
contourf(-7:7,-7:7,ssta_2-ssta_1,10,'linecolor','none');
caxis([-0.15 0.15]);
mycolor=m_colmap('diverging','step',64);
colormap(g3,mycolor(1:23:end,:));
axis square
box on
hold on
plot(0*ones(15,1),-7:1:7,'k:','linewidth',0.5);
plot(-7:1:7,0*ones(15,1),'k:','linewidth',0.5);
set(gca,'xlim',[-7 7],'ylim',[-7 7]);
set(gca,'xtick',-6:2:6,'xticklabel',-6:2:6);
set(gca,'ytick',-6:2:6,'yticklabel',[]);
set(gca,'ticklength',[0.015,0.015],'tickdir','in','fontname','Arial','fontunits','point','fontsize',7);
title('change','fontname','Arial','fontunits','point','fontsize',7);
text(-6.8,6.5,'c','fontname','Arial','fontunits','point','fontsize',8,'fontweight','bold');
% colorbar
h2=colorbar('horiz');
set(h2,'position',[0.68,0.37 0.28 0.02]);
set(h2,'ytick',-0.15:0.05:0.15,'yticklabel',{'-0.15','-0.1','-0.05','0','0.05','0.1','0.15'},'fontname','Arial','fontsize',7,'ticklength',0.02);
text(-0.5,-9.3,'\circC','fontname','Arial','fontunits','point','fontsize',7);

set(f,'RendererMode','manual','Renderer','painters');
print('-r600',[path_figure,'global mean ssta relative to Clim_TS1_1991-2020'],'-depsc');
close(f);




